Package: philr
Type: Package
Title: Phylogenetic partitioning based ILR transform for metagenomics
        data
Version: 1.37.0
Date: 2024-10-15
Authors@R: 
    c(person("Justin", "Silverman", role=c("aut", "cre"),
                     email = "jsilve24@gmail.com"),
      person(given = "Leo", family = "Lahti", role = c("ctb"),
             comment = c(ORCID = "0000-0001-5537-637X")))
Description: PhILR is short for Phylogenetic Isometric Log-Ratio Transform.
 This package provides functions for the analysis of compositional
 data (e.g., data representing proportions of different variables/parts).
 Specifically this package allows analysis of compositional data where the parts
 can be related through a phylogenetic tree  (as is common in microbiota survey
 data) and makes available the Isometric Log Ratio transform built from the
 phylogenetic tree and utilizing a weighted reference measure.
License: GPL-3
RoxygenNote: 7.3.2
Imports: ape, phangorn, tidyr, ggplot2, ggtree, methods
Suggests: testthat, knitr, ecodist, rmarkdown, BiocStyle, phyloseq,
        SummarizedExperiment, TreeSummarizedExperiment, glmnet, dplyr,
        mia
VignetteBuilder: knitr
biocViews: ImmunoOncology, Sequencing, Microbiome, Metagenomics,
        Software
URL: https://github.com/jsilve24/philr
BugReports: https://github.com/jsilve24/philr/issues
git_url: https://git.bioconductor.org/packages/philr
git_branch: devel
git_last_commit: 6f35184
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 22:24:56 UTC; biocbuild
Author: Justin Silverman [aut, cre],
  Leo Lahti [ctb] (ORCID: <https://orcid.org/0000-0001-5537-637X>)
Maintainer: Justin Silverman <jsilve24@gmail.com>

# Generally Helpful for Validation ----------------------------------------

# check for zeros and throw error if present
# target is just a name for the warning message
check.zeroes <- function(x, target){
    if (any(x==0)){
        warning(paste(target, "should not contain zeroes"))
    }
}

# convert vector to row vector.
vec_to_mat <- function(x){
    if (is.vector(x)) {
        n <- names(x)
        x <- matrix(x, nrow = 1)
        colnames(x) <- n
    }
    x
}

# ACCESSOR FUNCTIONS FROM NAMES TO NUMBERS --------------------------------

#' Convert between node/tip labels and integer node numbers
#'
#' Useful if you want to convert between node labels (\code{c}), tip labels
#' (\code{t}) and the internal integer number that identifies that node
#' (\code{nn}). Particularly for use with plotting libraries.
#'
#' @param tr object of type \code{phylo}
#' @param x vector of numerics or characters
#' @return vector
#' @name name_nodenumber_conversion
#' @examples
#' tr <- named_rtree(5)
#' name.to.nn(tr, 'n1')
#' name.to.nn(tr,c('n1','n2','t1'))
#' nn.to.name(tr, 1:9)
NULL

#' @rdname name_nodenumber_conversion
#' @export
nn.to.name <- function(tr, x){
    if(!is.numeric(x)) stop('node numbers must be numeric')
    labels <- c(tr$tip.label, tr$node.label)
    labels[x]
}

#' @rdname name_nodenumber_conversion
#' @export
name.to.nn <- function(tr, x){
    if(!is.character(x)) stop('node/tip names (x) should be a character vector')
    labels <- c(tr$tip.label, tr$node.label)
    match(x, labels)
}


# Generally Helpful for Plotting ------------------------------------------

#' Converts wide format ILR transformed data to long format
#'
#' Converts wide format ILR transformed data (see \code{\link{philr}}) to
#' long format useful in various plotting functions where long format data is
#' required.
#'
#' @param x PhILR transformed data in wide format (samples by balances)
#' (see \code{\link{philr}})
#' @param labels vector (of length \code{nrow(x)}) with labels to group
#' samples by
#' @return \code{x} in long format with columns
#' \itemize{
#' \item sample
#' \item labels
#' \item coord
#' \item value
#' }
#' @export
#' @importFrom tidyr gather_
#' @examples
#' tr <- named_rtree(5)
#' x <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65 # add small pseudocount
#' colnames(x) <- tr$tip.label
#'
#' x.philr <- philr(x, tree=tr, part.weights='enorm.x.gm.counts',
#'    ilr.weights='blw.sqrt', return.all=FALSE)
#'    convert_to_long(x.philr, rep(c('a','b'), 5))
convert_to_long <- function(x, labels){
    coord.names <- colnames(x)
    x.long <- as.data.frame(x)
    x.long$sample <- rownames(x.long)
    x.long$labels <- labels
    x.long <- gather_(x.long, "coord", "value",
                    setdiff(names(x.long), c("labels", "sample")))
    return(x.long)
}


# Helpful for generating examples -----------------------------------------

#' Generate random tree with named internal nodes
#'
#' Internal nodes are named by numbering and adding the prefix 'n'. This
#' function is laregly for use in examples throughout this package.
#'
#' @inheritParams ape::rtree
#' @importFrom ape rtree makeNodeLabel
#' @export
#'
#' @return An object of class "phylo"
#' @examples
#' named_rtree(5)
named_rtree <- function(n){
    tr <- rtree(n)
    makeNodeLabel(tr, 'number', 'n')
}

context('tree_node_id_conversion functions')

tr.fixed <- ape::read.tree(text="(((t1:0.9480410812,(t4:0.5734868464,
                           t3:0.5969958168)n4:0.5359996252)n3:0.2657330192,
                           t2:0.6697232309)n2:0.8426657049,t5:0.1043712671)n1;")
tr.rand <- ape::rtree(10)
tr.rand <- ape::makeNodeLabel(tr.rand, method="number", prefix='n')

test_that('all functions handle vectors on random tree', {
  # on vectors of length 1
  expect_length(nn.to.name(tr.rand, 1), 1)
  expect_length(name.to.nn(tr.rand, 'n1'), 1)

  # on longer vectors
  expect_length(nn.to.name(tr.rand, c(1, 2, 11)), 3) # nodes and tips
  expect_length(name.to.nn(tr.rand, c('n1', 'n2', 'n3', 't1')), 4) # nodes and tips
})

test_that('all functions give correst results on fixed tree', {
  expect_equal(nn.to.name(tr.fixed, c(1,2,8)), c("t1", "t4", "n3"))
  expect_equal(name.to.nn(tr.fixed, c("t1", "t4", "n3")), c(1,2,8))
})

test_that('get.ud.*** throws error if given a tip', {
  expect_error(get.ud.tips(tr.fixed, 't1'), "t1 is a tip")
  expect_error(get.ud.nodes(tr.fixed, 't1'), "t1 is a tip")
})
#
# test_that("vec_to_mat correctly handles named vectors", {
#   a <- c("a"=5, "b"=2)
#   b <- vec_to_mat(a)
#   expect_equal(colnames(b), names(a))
#   expect_equal(class(b), "matrix")
# })

#' miniclo
#'
#' small function to close (aka normalize by proportions, aka total sum scaling)
#' a dataset to a constant \code{k} (usually taken to be 1). After closure the row sums
#' of the dataset should sum to \code{k}.
#'
#' @param c dataset to be closed
#' @param k closure constant
#'
#' @return matrix (if c is a vector or matrix) or data.frame (if c is a data.frame)
#' @export
#'
#' @examples
#' c <- matrix(c(1,2,3,1,2,3,1,2,3), nrow = 3, byrow=TRUE)
#' miniclo(c)
#' miniclo(c, k=2)
miniclo <- function(c,k=1){
  check.zeroes(k, 'closure constant(k)')
  if(is.vector(c)) c <- matrix(c, nrow=1)
  (c/rowSums(c))*k
}


#' Shift data to origin given by p
#'
#' Shift must be applied before transformation
#'
#' @param x closed compositional data matrix (or vector)
#' @param y the shifted composition output by \code{shiftp}
#' @param p weights (should not be closed)
#' @return shifted data matrix \code{y} (no closure is applied) rows are
#'   samples, columns are parts
#' @author Justin Silverman & J. J. Egozcue
#' @references J. J. Egozcue, V. Pawlowsky-Glahn (2016) \emph{Changing the Reference
#'   Measure in the Simplex and its Weighting Effects}. Austrian Journal of
#'   Statistics 45(4):25-44
#' @name shift
#' @examples
#' p <- seq(.1,1,by=.2)
#' c <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65   # add a small pseudocount
#' x <- miniclo(c)
#' shiftp(x, p)
NULL

#' @rdname shift
#' @export
shiftp <- function(x, p){
  check.zeroes(p, "weights (p)")
  if(is.vector(x)) x <- matrix(x, nrow=1)
  y <- x / outer(rep(1,nrow(x)), p)
  y
}

#' @rdname shift
#' @export
shiftpInv <- function(y, p){
  check.zeroes(p, "weights (p)")
  if(is.vector(y)) y <- matrix(y, nrow=1)
  x <- y * outer(rep(1, nrow(y)), p)
  x
}



#' Weighted Geometric Means of Rows
#'
#' Calculates weighted geometric mean (see references). Note
#' if \code{p=rep(1, nrow(y))} (default) then this is just the
#' geometric mean of rows.
#'
#' @param y shifted data matrix (e.g., output of \link{shiftp})
#' @param p weights (should not be closed)
#'
#' @return vector (weighted geometric mean of rows)
#' @references J. J. Egozcue, V. Pawlowsky-Glahn (2016) \emph{Changing the Reference
#'   Measure in the Simplex and its Weighting Effects}. Austrian Journal of
#'   Statistics 45(4):25-44
#'
#' @seealso \code{\link{g.colMeans}}
#' @examples
#' p <- seq(.1,1,by=.2)
#' c <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65   # add a small pseudocount
#' x <- miniclo(c)
#' y <- shiftp(x, p)
#' philr:::g.rowMeans(y, p)
g.rowMeans <- function(y, p=rep(1, nrow(y))){
  sp <- sum(p) # as given in text on page 4
  exp(1/sp*rowSums(log(y)%*%diag(p)))
}


#' Geometric Means of Columns
#'
#' Calculates geometric mean of columns. Does not calculate
#' WEIGHTED geometric means (vs. \link{g.rowMeans})
#'
#' @param x matrix or vector
#'
#' @return vector (geometric mean of columns)
#'
#' @seealso g.rowMeans
#' @examples
#' philr:::g.colMeans(rbind(c(2,4,4), c(2,4,4)))
g.colMeans <- function(x){
  if(is.vector(x)) x <- matrix(x, nrow=1)
  exp(colMeans(log(x)))
}


#equation 7
inner.prodp <- function(y1,y2,p){
  sum(p*clrp(y1,p)*clrp(y2,p))
}

normp <- function(y,p){
  sqrt(inner.prodp(y,y,p))
}

#' Weighted CLR Transform
#'
#' @param y shifted data matrix (e.g., output of \link{shiftp})
#' @param p weights (should not be closed)
#' @param y.star a data matrix that represents data transformed by \code{clrp}
#' @return matrix
#' @details Note that this function will close the dataset \code{y} to 1.
#' @rdname weighted_clr
#' @details Inverting \code{clrp} transform should be followed by \code{shiftpInv}
#' to return to unshifted original compositoin (see examples).
#' @export
#'
#' @author Justin Silverman
#' @references J. J. Egozcue, V. Pawlowsky-Glahn (2016) \emph{Changing the Reference
#'   Measure in the Simplex and its Weighting Effects}. Austrian Journal of
#'   Statistics 45(4):25-44
#' @examples
#' p <- seq(.1,1,by=.2)
#' c <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65   # add a small pseudocount
#' x <- miniclo(c)
#' y <- shiftp(x, p)
#' y.star <- clrp(y, p)
#' y.star
#'
#' # Untransform data (note use of shiftp and miniclo to return to x)
#' y.closed <- clrpInv(y.star)
#' all.equal(miniclo(shiftpInv(y.closed, p)), x)
clrp <- function(y, p){
  check.zeroes(y, 'dataset')
  check.zeroes(p, 'weights(p)')

  if(is.vector(y)) y <- matrix(y, nrow=1)
  y <- miniclo(y)
  log(y/g.rowMeans(y,p))
}

#' @rdname weighted_clr
#' @export
clrpInv <- function(y.star){
  if(is.vector(y.star)) y.star <- matrix(y.star, nrow=1)
  miniclo(exp(y.star))
}



#' Weighted ILR Transform
#'
#' Calculated using weighted CLR transform (\link{clrp})
#'
#' @param y shifted data matrix (e.g., output of \link{shiftp})
#' @param y.star a data matrix that represents data transformed by \code{ilrp}
#' @param p weights (should not be closed)
#' @param V weighted contrast matrix (e.g., output of \link{buildilrBasep})
#'
#' @return matrix
#' @export
#' @author Justin Silverman
#' @references J. J. Egozcue, V. Pawlowsky-Glahn (2016) \emph{Changing the Reference
#'   Measure in the Simplex and its Weighting Effects}. Austrian Journal of
#'   Statistics 45(4):25-44
#' @rdname weighted_ilr
#' @seealso \code{\link{philrInv}}
#' @examples
#' # Weights
#' p <- seq(.1,1,by=.2)
#'
#' # Shifted Composition
#' c <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65   # add a small pseudocount
#' x <- miniclo(c)
#' y <- shiftp(x, p)
#'
#' # Contrast Matrix
#' tr <- named_rtree(5)
#' sbp <- phylo2sbp(tr)
#' V <- buildilrBasep(sbp, p)
#'
#' y.star <- ilrp(y, p, V)
#' y.star
#'
#' # Untransform data (note use of shiftp and miniclo to return to x)
#' y.closed <- ilrpInv(y.star, V)
#' all.equal(miniclo(shiftpInv(y.closed, p)), x, check.attributes=FALSE)
ilrp <- function(y,p,V){
  check.zeroes(p, 'weights(p)')
  check.zeroes(y, 'dataset')

  # if(is.vector(y)) y <- matrix(y, nrow=1) # run in clrp anyways
  clrp(y,p)%*%diag(p)%*%V
}

#' @rdname weighted_ilr
#' @export
ilrpInv <- function(y.star, V){
  if(is.vector(y.star)) y.star <- matrix(y.star, nrow=1)
  miniclo(exp(y.star%*%t(V)))
}


#' Weighted ILR Contrast Matrix
#'
#' @param W sequantial binary partition matrix (e.g., signary matrix; output of
#'   \link{phylo2sbp})
#' @param p weights (should not be closed)
#' @return matrix
#' @export
#' @author Justin Silverman (adapted from compositions::gsi.buildilrBase)
#' @references J. J. Egozcue, V. Pawlowsky-Glahn (2016) \emph{Changing the Reference
#'   Measure in the Simplex and its Weighting Effects}. Austrian Journal of
#'   Statistics 45(4):25-44
#' @examples
#' p <- seq(.1,1,by=.2)
#' tr <- named_rtree(5)
#' sbp <- phylo2sbp(tr)
#' buildilrBasep(sbp, p)
buildilrBasep <- function(W,p){
    check.zeroes(p, 'weights (p)')

    W = as.matrix(W)
    nc = ncol(W)
    D = nrow(W)
    isPos = (W > 0)
    isNeg = (W < 0)
    nPos = colSums(isPos*p)
    nNeg = colSums(isNeg*p)
    normConst = sqrt(nPos*nNeg/(nPos+nNeg))
    negPortion = -1/nNeg*t(isNeg)*normConst
    posPortion = 1/nPos*t(isPos)*normConst
    W = negPortion + posPortion
    return(t(W))
}

context("Weighted ILR Calculations")

test_that('check.zeroes throws proper waring',{
  expect_warning(check.zeroes(c(1,1,0), 'x'), 'x should not contain zeroes')
})

test_that('shiftp function handles both matricies and vectors', {
  x1 <- c(1,2,3)
  x2 <- matrix(c(1,2,3,1,2,3,1,2,3), nrow = 3, byrow=TRUE)
  p <- c(1, .1, .5)

  expect_equal(shiftp(x1, p), matrix(c(1, 20, 6), nrow=1))
  expect_equal(shiftp(x2, p), matrix(rep(c(1, 20, 6), 3), nrow=3, byrow=TRUE))
})

test_that('shiftpInv function reverses Shiftp', {
  x1 <- matrix(c(1,2,3), nrow=1)
  x2 <- matrix(c(1,2,3,1,2,3,1,2,3), nrow = 3, byrow=TRUE)
  p <- c(1, .1, .5)
  y1 <- shiftp(x1, p)
  y2 <- shiftp(x2, p)

  expect_equal(shiftpInv(y1, p), x1)
  expect_equal(shiftpInv(y2, p), x2)
})

test_that('miniclo function handles both matricies and vectors', {
  x1 <- c(2,4,4)
  x2 <- matrix(c(2,4,4,2,4,4,2,4,4), nrow = 3, byrow=TRUE)

  expect_equal(miniclo(x1), matrix(x1/sum(x1), nrow = 1))
  expect_equal(miniclo(x2), x2/rowSums(x2))
  expect_equal(miniclo(data.frame(x2)), data.frame(x2/rowSums(x2)))
})

test_that('BuildilrBasep returns correct results', {
  sbp <- rbind(c(1,0), c(-1,1), c(-1,-1))
  #colnames(sbp) <- c('n1', 'n2')
  #rownames(sbp) <- c('otu1', 'otu2', 'otu3')
  p <- c(1, 1, 0.5)

  expect_equal(buildilrBasep(sbp, p),
                    rbind(c(0.7745967,  0.0000000),
                          c(-0.5163978, 0.5773503),
                          c(-0.5163978, -1.1547005)),
                    tolerance=1e-7)
})

test_that('g.rowMeans returns correct', {
  x <- matrix(c(2,4,4,2,4,4,2,4,4), nrow = 3, byrow=TRUE)
  p <- rep(1, 3)

  expect_equal(g.rowMeans(x, p), rep(32^(1/3), 3))

  # Test defaults have not been changed
  expect_equal(g.rowMeans(x), rep(32^(1/3), 3))
})

test_that('g.colMeans returns correct', {
  x <- matrix(c(2,4,4,2,4,4,2,4,4), nrow = 3, byrow=TRUE)

  expect_equal(g.colMeans(x), c(2,4,4))
})

test_that('normp returns zero for neutral element', {
  x <- c(2,2,2)
  p <- c(1,1,1)
  expect_equal(normp(x, p), 0)
})

test_that('ilrpInv reverses effect of ilrp', {
  p <- c(1,1,1,.1,.5)
  tr <- named_rtree(5)
  sbp <- phylo2sbp(tr)
  V <- buildilrBasep(sbp, p)
  x <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65   # add a small pseudocount
  x <- miniclo(x)
  y <- shiftp(miniclo(x), p)
  y.star <- ilrp(y, p, V)

  y.inversed <- ilrpInv(y.star, V)

  expect_equivalent(y.inversed, miniclo(y))
  expect_equivalent(miniclo(shiftpInv(y.inversed, p)), x)
})

#' Data transformation and driver of PhILR.
#'
#' This is the main function for building the phylogenetic ILR basis,
#' calculating the weightings (of the parts and the ILR coordinates) and then
#' transforming the data.
#' 
#' @aliases build.phylo.ilr
#' @param x \strong{matrix} of data to be transformed (samples are rows, compositional parts are
#'   columns) - zero must be dealt with either with pseudocount, multiplicative replacement, or
#'   another method.
#' @param sbp (Optional) give a precomputed sbp matrix \code{\link{phylo2sbp}} if you are going to
#'   build multiple ILR bases (e.g., with different weightings).
#' @param part.weights weightings for parts, can be a named vector with names corresponding to
#'   \code{colnames(x)} otherwise can be a string, options include: \describe{
#'   \item{\code{'uniform'}}{(default) uses the uniform reference measure}
#'   \item{\code{'gm.counts'}}{geometric mean of parts of x} \item{\code{'anorm'}}{aitchison norm of
#'   parts of x (after closure)} \item{\code{'anorm.x.gm.counts'}}{\code{'anorm'} times
#'   \code{'gm.counts'}} \item{\code{'enorm'}}{euclidean norm of parts of x (after closure)}
#'   \item{\code{'enorm.x.gm.counts'}}{\code{'enorm'} times \code{'gm.counts'}, often gives good
#'   results} }
#' @param ilr.weights weightings for the ILR coordiantes can be a named vector with names
#'   corresponding to names of internal nodes of \code{tree} otherwise can be a string, options
#'   include: \describe{ \item{\code{'uniform'}}{(default) no weighting of the ILR basis}
#'   \item{\code{'blw'}}{sum of children's branch lengths} \item{\code{'blw.sqrt'}}{square root of
#'   \code{'blw'} option} \item{\code{'mean.descendants'}}{sum of children's branch lengths PLUS the
#'   sum of each child's mean distance to its descendent tips} }
#' @param return.all return all computed parts (e.g., computed sign matrix(\code{sbp}), part
#'   weightings (code{p}), ilr weightings (code{ilr.weights}), contrast matrix (\code{V})) as a list
#'   (default=\code{FALSE}) in addition to in addition to returning the transformed data
#'   (\code{.ilrp}). If \code{return.all==FALSE} then only returns the transformed data (not in list
#'   format) If \code{FALSE} then just returns list containing \code{x.ilrp}.
#' @param abund_values A single character value for selecting the
#'   \code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-class]{assay}} to be used. Only
#'   used when \code{x} is object from this class. Default: "counts".
#' @param pseudocount optional pseudocount added to observation matrix (`x`) to avoid numerical
#'   issues from zero values. Default value is 0 which has no effect (allowing the user to handle
#'   zeros in their own preffered way before calling philr). Values < 0 given an error.
#' @param ... other parameters passed to philr.data.frame or philr.TreeSummarizedExperiment
#' @inheritParams calculate.blw
#' @details This is a utility function that pulls together a number of other functions in
#'   \code{philr}. The steps that are executed are as follows: \enumerate{ \item Create sbp (sign
#'   matrix) if not given \item Create parts weightings if not given \item Shift the dataset with
#'   respect to the new reference measure (e.g., part weightings) \item Create the basis contrast
#'   matrix from the sign matrix and the reference measure \item Transform the data based on the
#'   contrast matrix and the reference measure \item Calculate the specified ILR weightings and
#'   multiply each balance by the corresponding weighting } Note for both the reference measure
#'   (part weightings) and the ILR weightings, specifying \code{'uniform'} will give the same
#'   results as not weighting at all. \cr \cr Note that some of the prespecified part.weights assume
#'   \code{x} is given as counts and not as relative abundances. Except in this case counts or
#'   relative abundances can be given.
#'
#' The tree argument is ignored if the \code{x} argument is
#' \code{\link[phyloseq:phyloseq-class]{assay}} or
#' \code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-class]{assay}}
#' These objects can include a phylogenetic tree. If the phylogenetic tree
#' is missing from these objects, it should be integrated directly in these
#' data objects before running \code{philr}. Alternatively, you can always
#' provide the abundance matrix and tree separately in their standard formats.
#'
#' If you have a 
#' \code{\link[SummarizedExperiment:SummarizedExperiment-class]{assay}},
#' this can be converted into
#' \code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-class]{assay}},
#' to incorporate tree information.
#'
#' @return matrix if \code{return.all=FALSE}, if \code{return.all=TRUE} then
#' a list is returned (see above).
#' @author Justin Silverman; S3 methods by Leo Lahti
#' @export 
#' @seealso \code{\link{phylo2sbp}} \code{\link{calculate.blw}}
#' @examples
#' # Prepare example data
#' tr <- named_rtree(5)
#' x <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65 # add a small pseudocount
#' colnames(x) <- tr$tip.label
#' philr(x, tr, part.weights='enorm.x.gm.counts',
#'                ilr.weights='blw.sqrt', return.all=FALSE)
#'
#' # Running philr on a TreeSummarizedExperiment object
#'
#' ## Prepare example data
#' library(mia)
#' library(tidyr)
#' data(GlobalPatterns, package="mia")
#'
#' ## Select prevalent taxa 
#' tse <-  GlobalPatterns %>% subsetByPrevalentTaxa(
#'                                detection = 3,
#'                                prevalence = 20/100,
#'                                as_relative = FALSE)
#'
#' ## Pick taxa that have notable abundance variation across sammples
#' variable.taxa <- apply(assay(tse, "counts"), 1, function(x) sd(x)/mean(x) > 3.0)
#' tse <- tse[variable.taxa,]
#'
#' # Collapse the tree
#' tree <- ape::keep.tip(phy = rowTree(tse), tip = rowLinks(tse)$nodeNum)
#' rowTree(tse) <- tree
#'
#' ## Add a new assay with a pseudocount 
#' assays(tse)$counts.shifted <- assay(tse, "counts") + 1
#' 
#' ## Run philr for TreeSummarizedExperiment object
#' ## using the pseudocount data
#' res.tse <- philr(tse, part.weights='enorm.x.gm.counts',
#'                ilr.weights='blw.sqrt', return.all=FALSE,
#'                abund_values="counts.shifted")
#'
#' # Running philr on a phyloseq object
#' \dontrun{
#'   pseq <- convertToPhyloseq(tse)
#'   res.pseq <- philr(pseq, part.weights='enorm.x.gm.counts',
#'                ilr.weights='blw.sqrt', return.all=FALSE,
#'                pseudocount=0.5)
#' }
#'
philr <- function(x, tree=NULL, sbp=NULL, part.weights='uniform', ilr.weights='uniform',
                  return.all=FALSE, pseudocount=0, abund_values="counts", ...) {
  UseMethod("philr")
}


#' @export 
philr.default <- function(x, ...){
    warning(paste("philr does not know how to handle object of class ",
    class(x),
    "and can only be used on classes TBA"))
}

#' @export 
philr.numeric <- function(x, tree, ...){
    philr.data.frame(x, tree, ...)
}

#' @export 
philr.phyloseq <- function(x, ...){

    otu.table <- t(phyloseq::otu_table(x))
    tree <- phyloseq::phy_tree(x)

    philr.data.frame(otu.table, tree=tree, ...)

}


#' @export
philr.TreeSummarizedExperiment <- function(x, tree=NULL, sbp=NULL,
                            part.weights='uniform', ilr.weights='uniform',
                            return.all=FALSE, pseudocount=0,
                            abund_values="counts", ...){

    tree <- TreeSummarizedExperiment::rowTree(x)
    otu.table <- t(SummarizedExperiment::assays(x)[[abund_values]])
  philr.data.frame(otu.table, tree=tree, sbp=sbp, part.weights=part.weights,
                   ilr.weights=ilr.weights, return.all=return.all,
                   pseudocount=pseudocount, ...)
}

#' @export 
philr.matrix <- function(x, tree, ...){
    philr.data.frame(x, tree, ...)
}

#' @export
philr.array <- function(x, tree, ...){
    philr.data.frame(x, tree, ...)
}

#' @export 
philr.data.frame <- function(x, tree, sbp=NULL,
                            part.weights='uniform', ilr.weights='uniform',
                            return.all=FALSE, pseudocount=0, ...){  
    if (pseudocount < 0) stop("pseudocount must be >= 0")
    if (!is.numeric(pseudocount)) stop("pseudocount must be numeric")
    if (length(pseudocount) != 1) stop("pseudocount must be a single number")

    # Convert x to mat with warning
    x.name <- deparse(substitute(x))
    if (is.data.frame(x)) {
        st <- paste("Converting ", x.name, " to matrix from data.frame",
            " consider adding as.matrix(", x.name, ") to function call",
            " to control conversion manually", sep="")
        warning(st)
        x <- as.matrix(x)
    }

    # Convert vector input for x to matrix
    x <- vec_to_mat(x)

    # add pseudocount
    x <- x + pseudocount
    
    # Check for Zero values in x
    if (any(x == 0)){
        stop('Zero values must be removed either through use of pseudocount, multiplicative replacement or other method. For convenience, you can use the "pseudocount" argument to philr.')
    }

    # Create the sequential binary partition sign matrix
    if (is.null(sbp)){
        message('Building Sequential Binary Partition from Tree...')
        sbp <-  phylo2sbp(tree)
    } else {
        if ( (nrow(sbp)!=ncol(x)) | (ncol(sbp)!=ncol(x)-1) ){
            stop("given sbp does not match dimentions required dimentions 
                (e.g., ncol(x) x ncol(x)-1")
        }
    }
    if (is.null(colnames(x))) {
        stop("Input data must have column names that align with phylogenetic tree to prevent logical errors.")
    }
    sbp <- sbp[colnames(x), ] #Very Important line to avoid logical errors

    # Now need to create the weights on the parts
    if (is.null(part.weights)){part.weights <- 'uniform'}
    if (part.weights=='uniform'){
        p <- rep(1, ncol(x))
        names(p) <- rownames(sbp)
    } else if (part.weights=='gm.counts'){
        p <- g.colMeans(x)
        p <- p[rownames(sbp)]
    } else if (part.weights=='anorm'){
        p <- apply(miniclo(t(x)), 1, function(xx) normp(xx, rep(1, nrow(x))))
    } else if (part.weights=='anorm.x.gm.counts'){
        gm.counts <- g.colMeans(x)
        gm.counts <- gm.counts[rownames(sbp)]
        anorm <- apply(miniclo(t(x)), 1, function(xx) normp(xx, rep(1, nrow(x))))
        anorm <- anorm[rownames(sbp)]
        p <- gm.counts*anorm
    } else if (part.weights=='enorm') {
        enorm <- apply(miniclo(t(x)), 1, function(xx) sqrt(sum(xx^2)))
        enorm <- enorm[rownames(sbp)]
        p <- enorm
    } else if (part.weights=='enorm.x.gm.counts'){
        gm.counts <- g.colMeans(x)
        gm.counts <- gm.counts[rownames(sbp)]
        enorm <- apply(miniclo(t(x)), 1, function(xx) sqrt(sum(xx^2)))
        enorm <- enorm[rownames(sbp)]
        p <- gm.counts*enorm
    }

    # Make sure everything is lined up (else throw an error)
    if (!all.equal(rownames(sbp), colnames(x), names(p))) {
        stop("Rownames of SBP, Colnames of x, and names of part weights not equal!")
    }

    # shift the dataset with respect to the new reference measure
    x <- shiftp(miniclo(x), p)

    # Now create basis contrast matrix
    message('Building Contrast Matrix...')
    V <- buildilrBasep(sbp, p)

    # Finally transform the x
    message('Transforming the Data...')
    x.ilrp <- ilrp(x, p, V)

    # Now calculate ILR Weightings
    if (is.character(ilr.weights)){
        message('Calculating ILR Weights...')
        if (ilr.weights=='blw'){
            ilr.weights <- calculate.blw(tree, method='sum.children')
        } else if (ilr.weights=='blw.sqrt'){
            ilr.weights <- sqrt(calculate.blw(tree, method='sum.children'))
        } else if (ilr.weights=='uniform'){
            ilr.weights <- rep(1, ncol(x.ilrp))
            names(ilr.weights) <- colnames(x.ilrp)
        } else if (ilr.weights=='mean.descendants'){
            ilr.weights <- calculate.blw(tree, method='mean.descendants')
        }
    } else { # Validate input of ilr.weights
        if (!is.numeric(ilr.weights) | length(ilr.weights) != ncol(x.ilrp)){
            stop("ilr.weights must be recognized string or numeric vector of 
            length = ncol(x)-1")
        }
    }

    # TODO: Speed up by not computing if 'uniform'
    if (!is.null(colnames(x.ilrp))){
        ilr.weights <- ilr.weights[colnames(x.ilrp)]
    }
    # ilr.weights <- ilr.weights[colnames(x.ilrp)]
    tmp.names <- colnames(x.ilrp)
    x.ilrp <- x.ilrp %*% diag(ilr.weights)
    colnames(x.ilrp) <- tmp.names

    # Build return list
    if (return.all==FALSE)return(x.ilrp)
    if (return.all==TRUE){
        l.return = list()
        l.return[['x.ilrp']] <- x.ilrp
        l.return[['sbp']] <- sbp
        l.return[['p']] <- p      # the part weights
        l.return[['V']] <- V      # the contrast matrix
        l.return[['ilr.weights']] <- ilr.weights
    }
    return(l.return)
}

#' Inverse of PhILR Transform
#'
#' @param x.ilrp transformed data to which the inverse transform will be applied
#' @param tree (optional) to be used to build sbp and contrast matrix
#' (see details)
#' @param sbp (optional) the sbp (sequential binary partition) used to build a
#' contrast matrix (see details)
#' @param V (optional) the contrast matrix (see details)
#' @param part.weights weightings for parts, can be a named vector with names
#' corresponding to \code{colnames(x)}. Defaults to 'uniform'
#' (part.weights = 1,...,1)
#' @param ilr.weights weightings for the ILR coordiantes can be a named vector
#' with names corresponding to names of internal nodes of \code{tree}.
#' Defaults to 'uniform' (ilr.weights = 1,...,1)
#'
#' @details This is a utility function for calculating the inverse of the
#' \code{\link{philr}} transform. Note that at least one of the following
#' parameters must be specified (\code{tree}, \code{sbp}, or \code{V}).
#' @return a matrix of compositions (rows are samples, columns are parts),
#' function removes the effects of ilr weights, part weights, and unshifts
#' the composition.
#'
#' @author Justin Silverman
#' @export
#' @seealso \code{\link{philr}}
#'
#' @examples
#'  tr <- named_rtree(5)
#'  x <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65 # add small pseudocount
#'  colnames(x) <- tr$tip.label
#'  d <- philr(x, tr, part.weights='enorm.x.gm.counts',
#'                 ilr.weights='blw.sqrt', return.all=TRUE)
#'  d.inverted <- philrInv(d$x.ilrp, V=d$V, part.weights = d$p,
#'                         ilr.weights = d$ilr.weights)
#'  all.equal(miniclo(x), d.inverted)
philrInv <- function(x.ilrp, tree=NULL, sbp=NULL, V=NULL, part.weights=NULL, ilr.weights=NULL){
    if (all(c(is.null(tree), is.null(sbp), is.null(V)))){
        stop('At least one of the parameters (tree, sbp, V) must be non-null')
    }

    # Convert vector input for x to matrix
    x.ilrp <- vec_to_mat(x.ilrp)

    # Inverse ILR -> y (the shifted composition - but closed)
    if (is.null(part.weights)){
        part.weights <- rep(1, ncol(x.ilrp)+1)
    }

    if (!is.null(V)) NULL
    else if (!is.null(sbp)) V <- buildilrBasep(sbp, part.weights)
    else V <- buildilrBasep(phylo2sbp(tree), part.weights)
    V <- V[,colnames(x.ilrp)] # make sure everything is lined up

    # Undo ILR weights - note: doing nothing (e.g., not matching criteria)
    # is equivalent to undoing uniform ilr.weights (1,...,1)
    if (!is.null(ilr.weights)) {
        ilr.weights <- ilr.weights[colnames(x.ilrp)] # ensure things are lined up
        x.ilrp <- x.ilrp / outer(rep(1,nrow(x.ilrp)), ilr.weights)
    }

    # Make sure everything is lined up (else throw an error)
    if (!all.equal(colnames(V), colnames(x.ilrp))) {
        stop("Colnames of V, Colnames of x!")
    }

    if (!all(part.weights==1)){
        if (!all.equal(rownames(V), names(part.weights))){
            stop("rownames of V and names of parts.weights not equal")
        }
    }

    y <- ilrpInv(x.ilrp, V)
    x <- miniclo(shiftpInv(y, part.weights))
    x
}

context("philr and philrInv functions")

test_that("philrInv inverses the philr transform", {
  tr <- named_rtree(5)
  x <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65   # add a small pseudocount
  colnames(x) <- tr$tip.label

  d <- philr(x, tree=tr, part.weights='enorm.x.gm.counts',
             ilr.weights='blw.sqrt', return.all=TRUE)

  expect_equal(philrInv(d$x.ilrp, V=d$V, part.weights = d$p, ilr.weights = d$ilr.weights),
               miniclo(x))
})

test_that("philr and philrInv handles vectors and default uniform arguments", {
  tr <- named_rtree(5)
  x <- c(1,4,1,22,2)
  names(x) <- tr$tip.label

  x.ilr <- philr(x, tree=tr, return.all=FALSE)

  expect_equivalent(philrInv(x.ilr, tr),
               miniclo(x))
})


test_that("philr and philrInv conserve distances of circle", {
  phy1 <- named_rtree(3)
  phy2 <- named_rtree(3)
  t <- seq(0, 2*pi, by = 0.1)
  x <- cos(t)
  y <- sin(t)
  circ1 <- cbind(x, y)
  colnames(circ1) <- c("n1", "n2")

  circ2 <- philr(philrInv(circ1, tree = phy1), tree = phy2)

  expect_equal(max(dist(circ1)), max(dist(circ2)))
})


test_that("philr handles data.frame input with warning", {
  tr <- named_rtree(5)
  x <- c(1,4,1,22,2)
  names(x) <- tr$tip.label
  xxxx <- as.data.frame(t(as.data.frame(x)))

  expect_warning(philr(xxxx, tree=tr, return.all=FALSE), "xxxx")
})

## ----echo=TRUE, message=FALSE-------------------------------------------------
library(philr); packageVersion("philr")
library(ape); packageVersion("ape")
library(ggplot2); packageVersion("ggplot2")

## ----echo=TRUE, message=FALSE-------------------------------------------------
library(mia); packageVersion("mia")
library(dplyr); packageVersion("dplyr")
data(GlobalPatterns, package = "mia")

## ----message=FALSE, warning=FALSE---------------------------------------------
## Select prevalent taxa 
tse <-  GlobalPatterns %>% subsetByPrevalentTaxa(
                               detection = 3,
                               prevalence = 20/100,
                               as_relative = FALSE)

## Pick taxa that have notable abundance variation across sammples
variable.taxa <- apply(assays(tse)$counts, 1, function(x) sd(x)/mean(x) > 3.0)
tse <- tse[variable.taxa,]
# Collapse the tree!
# Otherwise the original tree with all nodes is kept
# (including those that were filtered out from rowData)
tree <- ape::keep.tip(phy = rowTree(tse), tip = rowLinks(tse)$nodeNum)
rowTree(tse) <- tree

## Add a new assay with a pseudocount 
assays(tse)$counts.shifted <- assays(tse)$counts + 1 

## ----echo=FALSE---------------------------------------------------------------
tse

## ----message=FALSE, warning=FALSE---------------------------------------------
library(ape); packageVersion("ape")
is.rooted(tree) # Is the tree Rooted?
is.binary(tree) # All multichotomies resolved?

## ----message=FALSE, warning=FALSE---------------------------------------------
tree <- makeNodeLabel(tree, method="number", prefix='n')

# Add the modified tree back to the (`TreeSE`) data object 
rowTree(tse) <- tree

## -----------------------------------------------------------------------------
# Extract taxonomy table from the TreeSE object
tax <- rowData(tse)[,taxonomyRanks(tse)]

# Get name balances
name.balance(tree, tax, 'n1')

## -----------------------------------------------------------------------------
otu.table <- t(as(assays(tse)$counts.shifted, "matrix"))
tree <- rowTree(tse)
metadata <- colData(tse)
tax <- rowData(tse)[,taxonomyRanks(tse)]

otu.table[1:2,1:2] # OTU Table
tree # Phylogenetic Tree
head(metadata,2) # Metadata
head(tax,2) # taxonomy table

## -----------------------------------------------------------------------------
human.samples <- factor(colData(tse)$SampleType %in% c("Feces", "Mock", "Skin", "Tongue"))

## ----message=FALSE------------------------------------------------------------
gp.philr <- philr(otu.table, tree, 
                  part.weights='enorm.x.gm.counts', 
                  ilr.weights='blw.sqrt')
gp.philr[1:5,1:5]

## ----message=FALSE------------------------------------------------------------
gp.philr <- philr(tse, abund_values = "counts.shifted",
                  part.weights='enorm.x.gm.counts', 
                  ilr.weights='blw.sqrt')

## ----message=FALSE------------------------------------------------------------
pseq <- convertToPhyloseq(tse, assay.type="counts.shifted")
gp.philr <- philr(pseq, 
                  part.weights='enorm.x.gm.counts', 
                  ilr.weights='blw.sqrt')


## -----------------------------------------------------------------------------
# Distances between samples based on philr transformed data
gp.dist <- dist(gp.philr, method="euclidean") 

# Calculate MDS for the distance matrix
d <- as.data.frame(cmdscale(gp.dist))
colnames(d) <- paste0("PC", 1:2)

## -----------------------------------------------------------------------------
# Add some metadata for the visualization 
d$SampleType <- factor(metadata$SampleType)

# Create a plot
ggplot(data = d,
  aes(x=PC1, y=PC2, color=SampleType)) +
  geom_point() +
  labs(title = "Euclidean distances with phILR")

## ----message=FALSE, warning=FALSE---------------------------------------------
library(glmnet); packageVersion('glmnet')
glmmod <- glmnet(gp.philr, human.samples, alpha=1, family="binomial")

## -----------------------------------------------------------------------------
top.coords <- as.matrix(coefficients(glmmod, s=0.2526))
top.coords <- rownames(top.coords)[which(top.coords != 0)]
(top.coords <- top.coords[2:length(top.coords)]) # remove the intercept as a coordinate

## -----------------------------------------------------------------------------
tc.names <- sapply(top.coords, function(x) name.balance(tree, tax, x))
tc.names

## -----------------------------------------------------------------------------
votes <- name.balance(tree, tax, 'n730', return.votes = c('up', 'down'))
votes[[c('up.votes', 'Family')]]   # Numerator at Family Level
votes[[c('down.votes', 'Family')]] # Denominator at Family Level

## ----message=FALSE, warning=FALSE---------------------------------------------
library(ggtree); packageVersion("ggtree")
library(dplyr); packageVersion('dplyr')

## ----message=FALSE, warning=FALSE---------------------------------------------
tc.nn <- name.to.nn(tree, top.coords)
tc.colors <- c('#a6cee3', '#1f78b4', '#b2df8a', '#33a02c', '#fb9a99')
p <- ggtree(tree, layout='fan') +
  geom_balance(node=tc.nn[1], fill=tc.colors[1], alpha=0.6) +
  geom_balance(node=tc.nn[2], fill=tc.colors[2], alpha=0.6) +
  geom_balance(node=tc.nn[3], fill=tc.colors[3], alpha=0.6) +
  geom_balance(node=tc.nn[4], fill=tc.colors[4], alpha=0.6) +
  geom_balance(node=tc.nn[5], fill=tc.colors[5], alpha=0.6)
p <- annotate_balance(tree, 'n16', p=p, labels = c('n16+', 'n16-'),
                 offset.text=0.15, bar=FALSE)
annotate_balance(tree, 'n730', p=p, labels = c('n730+', 'n730-'),
                 offset.text=0.15, bar=FALSE)

## -----------------------------------------------------------------------------
gp.philr.long <- convert_to_long(gp.philr, human.samples) %>%
  filter(coord %in% top.coords)

ggplot(gp.philr.long, aes(x=labels, y=value)) +
  geom_boxplot(fill='lightgrey') +
  facet_grid(.~coord, scales='free_x') +
  labs(x = 'Human', y = 'Balance Value') +
  theme_bw()

## ----message=FALSE, warning=FALSE---------------------------------------------
library(tidyr); packageVersion('tidyr')

gp.philr.long %>%
  dplyr::rename(Human=labels) %>%
  dplyr::filter(coord %in% c('n16', 'n730')) %>%
  tidyr::spread(coord, value) %>%
  ggplot(aes(x=n16, y=n730, color=Human)) +
  geom_point(size=4) +
  labs(x = tc.names['n16'], y = tc.names['n730']) +
  theme_bw()

## ----echo=TRUE, message=FALSE-------------------------------------------------
sessionInfo()

#' Calculate Branch Length Weightings for ILR Coordinates
#'
#' Calculates the weightings for ILR coordinates based on branch lenghts of
#' a phylogenetic tree via a few different methods (see details).
#' @aliases calc.blw
#' @param tree a \code{phylo} class tree object that is binary (see
#' \code{\link[ape]{multi2di}})
#' @param method options include: (default) \code{'sum.children'} and
#' \code{'mean.descendants'}
#' see details for more information.
#' @return vector of weightings for ILR coordinates produced via specified
#' method.
#' @details
#' ILR balances built from a binary partition of a phylogenetic tree
#' can be imbued with branch length information. This function is helpful in
#' calculating those weightings.\cr \cr
#' There are a number of methods for calculating these weightings, the default
#' \code{'sum.children'} calculates the weighting for a given balance as the sum
#' of its two direct children's branch length. An alternative that has been
#' as yet less studied is \code{'mean.descendants'} to calculate the weighting
#' for a given balance as the sum of its two direct children's branch lengths
#' PLUS for each child the average distance from it to its descendant tips.
#' \cr \cr
#' \emph{Note:} That some trees contain tips with branch lengths of zero length.
#' This can result in that tip being unreasonably downweighted, as such this
#' function automatically adds a small pseudocount to those tips with zero
#' length (equal to the smallest non-zero)
#' branch length on the tree.
#' @author Justin Silverman
#' @export
#' @seealso \code{\link{philr}}
#' @examples
#' tr <- named_rtree(50)
#' calculate.blw(tr, method='sum.children')[1:10]
#' calculate.blw(tr, method='mean.descendants')[1:10]
calculate.blw <- function(tree, method='sum.children'){
    nTips = ape::Ntip(tree)

    # Note that some of the terminal branches of the tree have zero length.
    # In these cases will replace those zero values with
    # the minimum branch length (greater than 0) found in the tree.
    # Note this is like adding a psudocount to branch lengths.
    min.nonzero <- min(tree$edge.length[tree$edge.length>0 &
                        !is.na(tree$edge.length)])
    # Find the edges that end in tips and have zero length
    tip.edges.zero <- (tree$edge[,2] <= nTips) & (tree$edge.length == 0)
    # print warning/note statement
    n.replace <- sum(tip.edges.zero)
    if (n.replace >0 ){
        warning(paste('Note: a total of', sum(tip.edges.zero),
        'tip edges with zero length',
        'have been replaced with a small pseudocount of the minimum',
        'non-zero edge length (',min.nonzero,').',sep=" "))
        tree$edge.length[tip.edges.zero] <- min.nonzero
    }

    if (method=='sum.children')return(blw.sum.children(tree))
    else if (method=='mean.descendants') {
        return(blw.mean.descendants.sum.children(tree))
    }
}

# Now calculate Branch Length Weighting as the sum of a nodes
#  two (direct) child's weights
blw.sum.children <- function(tree){
    nTips =  nTips = ape::Ntip(tree)
    X <- phangorn::Children(tree, (nTips+1):(nTips+tree$Nnode))
    fun <- function(x, el)sum(el[x])
    EL <- numeric(max(tree$edge))
    EL[tree$edge[,2]] <- tree$edge.length
    res <- sapply(X, fun, EL)
    if(!is.null(tree$node.label)) names(res) <- tree$node.label
    res
}

# Calculates the sum of the children's nodes average distance to
# descendant tips
# Which should be a slightly better calculation than MDTT when we are
# primarily interested in weightings on ILR coordinates
blw.mean.descendants.sum.children <- function(tree){
    nTips = ape::Ntip(tree)
    X <- phangorn::Children(tree, (nTips+1):(nTips+tree$Nnode))

    # Children's average branch length to tips (zero for tips)
    BMD <- mean_dist_to_tips(tree)
    names(BMD) <- NULL
    BMD <- c(numeric(nTips), BMD)

    # Each child's edge length
    EL <- numeric(max(tree$edge))
    EL[tree$edge[,2]] <- tree$edge.length

    fun <- function(x, el, bmd)sum(el[x] + bmd[x])
    res <- sapply(X, fun, EL, BMD)
    if(!is.null(tree$node.label)) names(res) <- tree$node.label
    return(res)
}

#' Mean distance from internal nodes to descendant tips
#'
#' Calculates the mean distance from each internal node to its descendant tips
#'
#' @inheritParams calculate.blw
#' @details This is a function used by \code{\link{calculate.blw}} when
#'   \code{method='mean.descendants'}, there this function is called twice, once
#'   for each direct child of a given internal node and the results are summed
#'   for each node.
#' @export
#' @return vector (named if internal nodes are named)
#' @examples
#' tr <- named_rtree(5)
#' mean_dist_to_tips(tr)
mean_dist_to_tips <- function(tree){
    nTips = ape::Ntip(tree)

    dist <- ape::dist.nodes(tree)
    node.numbers <- (nTips+1):(nTips+tree$Nnode)
    chld.tips <- phangorn::Descendants(tree, (nTips+1):(nTips+tree$Nnode),
                "tips")

    # Turn dist into a nodes (rows) x tips (columns) matrix
    dist <- dist[node.numbers, 1:nTips]
    rownames(dist) <- 1:tree$Nnode

    # Calculate the average distance of a node to its tips
    fun <- function(n, d, c)mean(d[n,c[[n]]])
    res <- sapply(1:tree$Nnode, fun, dist, chld.tips)
    if(!is.null(tree$node.label)) names(res) <- tree$node.label
    return(res)
}

context('Branch Length Calculations')

library(ape)
tr.fixed <- read.tree(text="((t2:0.3708901014,((t1:0.5037344745,
                           t3:0.5299885271)n4:0.7873590044,
                           t5:0.4477706181)n3:0.8255127743)n2:0.1799265754,
                           t4:0.9563850679)n1;")

test_that('mean_dist_to_tips gives correct results on fixed tree', {
  mdtt <- mean_dist_to_tips(tr.fixed)

  expect_equal(length(mdtt), 4)
  expect_equal(mdtt[3], 1.018737, tolerance=3e-7, check.attributes=FALSE)
  expect_equivalent(mdtt[4], 0.5168615)
})

test_that('calculate.blw handles tip with edge length zero and gives correct results', {
  tr <- read.tree(text="((t1:0.3187429151,t2:0):0.3409723381,
                       t3:0.04305356415);")

  expect_warning(calculate.blw(tr), 'Note: a total of 1') # throws warning

  # replaces with pseudocount of min
  expect_equal(suppressWarnings(calculate.blw(tr, method='sum.children')),
               c(0.3840259, 0.3617965),
               tolerance=1e-7)
  expect_equal(suppressWarnings(calculate.blw(tr, method='mean.descendants')),
               c(0.5649241, 0.3617965),
               tolerance=1e-7)
})

#' Name a balance (coordinate) based on taxonomy
#'
#' For a given ILR balance (coordinate) assigns a name to the balance based on
#' a provided taxonomy table. This is useful for interpretation of the balances.
#'
#' @param tr an object of class \code{'phylo'}
#' @param tax a matrix/data.frame of taxonomy, rownames should correspond to
#' \code{tr$tip.labels} columns should be taxonomic levels (named) with
#' increasing taxonomic resolution from left to right (e.g., Phylum to the
#' left of Genus).
#' @param coord the name of a balance/internal node on the tree (given as a
#' string)
#' @param method currently only \code{'voting'} implemented. See Details.
#' @param thresh threshold for assignment of taxonomy to a given part of a
#' balance (must be greater than 0.5 if \code{method='voting'}; see details).
#' @param return.votes whether voting results by taxonomic level should be
#' shown for \code{coord}. Note: this is helpful when \code{name.balance} does
#' not return a clear winner, as may be the case when a given \code{coord}
#' represents more than one taxonomic lineage. votes are returned as a list
#' indexed by \code{colnames(tax)} Options include:
#' \describe{
#' \item{\code{NULL}}{(default) only returns the combined consensus name of
#'    the balance}
#' \item{\code{'up'}}{adds tallied votes for the 'up' node to the output list}
#' \item{\code{'down'}}{adds tallied votes for the 'down' node to the output
#'    list}
#' \item{\code{'self'}}{adds tallied votes for \code{coord} to the output list}
#' }
#' @return If \code{return.votes=NULL} returns a string of the form
#' (ex. 'Genus_Bacteroides/Phylum_Firmicutes'). Otherwise returns
#' a list with the above string as 'name', see Arguments for \code{show.votes}
#' for other optional returned items.
#' @details A bit of terminology:
#' \describe{
#' \item{coord}{this is the same as the names of the balances which should be
#' the same as the names of the internal nodes of \code{tr}}
#' \item{'up'}{this is the child node of \code{coord} that is represented in
#' the numerator of the \code{coord} balance.}
#' \item{'down'}{this is the child node of \code{coord} that is represented in
#' the denominator of the \code{coord} balance}
#' }
#' The method \code{'voting'} assigns the name of the each part of a balance
#' (e.g., numerator and denominator / each child of \code{coord}) as follows:
#' \enumerate{
#' \item First Subset \code{tax} to contain only descendent tips of the given
#' child of \code{coord}
#' \item Second At the finest taxonomic (farthest right of \code{tax}) see if
#' any one taxonomic label is present at or above \code{thresh}. If yes output
#' that taxonomic label (at that taxonomic level) as the label for that child
#' of \code{coord}. If no then move to coarser taxonomic level (leftward) and
#' repeat.
#' }
#' @author Justin Silverman
#' @importFrom methods as
#' @importFrom methods is
#' @export
#' @seealso \code{\link{philr}}
#' @examples
#' tr <- named_rtree(40)
#' tax <- data.frame(Kingdom=rep('A', 40),
#'                Phylum=rep(c('B','C'), each=20),
#'                Genus=c(sample(c('D','F'),20, replace=TRUE),
#'                        sample(c('G','H'), 20, replace=TRUE)))
#' rownames(tax) <- tr$tip.label
#' name.balance(tr, tax, 'n1')
#' name.balance(tr, tax, 'n34')
#' name.balance(tr,tax, 'n34', return.votes = c('up', 'down'))
name.balance <- function(tr, tax, coord, method="voting", thresh=0.95, return.votes=NULL){
    if (method=="voting"){
        # Get tips in 'up' and 'down' subtree
        l.tips <- get.ud.tips(tr,coord)

        tax <- as(tax, "matrix")
        # Subset tax table based on above
        tax.up <- tax[l.tips[['up']],]
        tax.down <- tax[l.tips[['down']],]

        # Get Voted Consensus for up and down taxa (character strings)
        up.voted <- vote.annotation(tax.up, voting.threshold=thresh)
        down.voted <- vote.annotation(tax.down, voting.threshold=thresh)

        # Combine into a string and output
        name <- paste(up.voted,"/",down.voted,sep="")

        if (is.null(return.votes)){
            return(name)
        } else {
            res <- list('name'=name)
        }
        if ('up' %in% return.votes){
            res[['up.votes']] <- tally.votes(tax, l.tips[['up']])
        }
        if ('down' %in% return.votes){
            res[['down.votes']] <- tally.votes(tax, l.tips[['down']])
        }
        if ('self' %in% return.votes){
            res[['self.votes']] <- tally.votes(tax, unlist(l.tips))
        }
    return(res)
  }
  # In the future can extend to other methods of annotation/naming
  # (other than just voting)
}


# Returns a list of the 'up' and 'down' subtree's root nodes
# e.g., the child node of a given coordinate
# nn is node number
#' @importFrom phangorn Children
get.ud.nodes <- function(tr,coord, return.nn=FALSE){
    nn <- name.to.nn(tr, coord) # get node number
    l.nodes <- list()
    child <- phangorn::Children(tr, nn)
    if (length(child) < 2) stop(paste0(coord,' is a tip'))
    if (return.nn==TRUE){
        l.nodes[['up']] <- child[1]
        l.nodes[['down']] <- child[2]
    } else{
        l.nodes[['up']] <- nn.to.name(tr, child[1])
        l.nodes[['down']] <- nn.to.name(tr, child[2])
    }
    return(l.nodes)
}

# Returns a list of the 'up' and 'down' subtree's values as a vector of tip
# ids (corresponds to up and down used for sbp creation)
# Each value is the ID of a tip
get.ud.tips <- function(tr,coord){
    l.tips <- list()
    child <- phangorn::Children(tr, name.to.nn(tr,coord))
    if (length(child) < 2) stop(paste0(coord,' is a tip'))
    # TODO: Bit of validation - consider better location    
    if (length(child) > 2) stop("Tree is not soley binary.") 
    l.tips[['up']] <- sapply(unlist(phangorn::Descendants(tr,child[1],
        type='tips')), function(x) nn.to.name(tr, x))
    l.tips[['down']] <- sapply(unlist(phangorn::Descendants(tr,child[2],
        type='tips')), function(x) nn.to.name(tr, x))
    return(l.tips)
}

# Find most concerved
# returns character
# NA are not counted but held against the winner in voting
# Candidate must have >= voting.threshold to be considered the winner
vote.annotation <- function(tax, voting.threshold=0.95){
    if (voting.threshold <= 0.5) {
        stop('voting.threshold must be > 0.5 for unique winner')
    }
    if (is(tax, "character")){ # e.g., is there only 1 voter here
        tmp.names <- names(tax)
        tax <- matrix(tax,nrow=1)
        colnames(tax) <- tmp.names
    }
    nr <- nrow(tax) # the number of tips
    nc <- ncol(tax) # the number of taxonomic ranks in table
    name <- NULL

    # evaluate in decreasing order of taxonomic resolution
    for (i in seq(nc,1)){ 
        votes <- tax[,i]
        if (all(is.na(votes))) {next}
        # drop NA votes but hold against the total number    
        votes <- votes[!is.na(votes)] 
        winner <- sort(table(votes), decreasing=TRUE)[1]
        # Arbitrarily set threshold to 95% of votes
        if (!is.na(winner) & (winner/nr >= voting.threshold)){ 
            name <- names(winner)
            # Try and append taxonomic rank to name if columns of tax table
            # are labeled
            if (!is.null(colnames(tax))) {
            name <- paste(colnames(tax)[i],'_',name,sep="")
        }
            break
        }   # Else try the next level up
    }
    if (is.null(name)){ # If no consensus vote found (above threshold)
        name <- "Unclear_Lineage_Identity"
    }
    return(name)
}

# Given a list of tax IDs (e.g., rownames in tax table)
# print out a easy to read list showing whats present at each taxonomic level.
# This is really to be used when You don't get a result you like with
# vote.annotation()
tally.votes <- function(tax,ids){
    l.votes <- list()
    nc <- ncol(tax) # the number of taxonomic ranks in the table
    for (i in seq(nc,1)){
        votes <- tax[ids,i]
        votes <- votes[!is.na(votes)]
        rank <- ifelse(!is.null(colnames(tax)), colnames(tax)[i],i)
        l.votes[[rank]] <- table(votes)
    }
    return(l.votes)
}

#' Create Sequential Binary Partition from Phylogenetic Tree
#'
#' This function converts a binary phylogenetic tree to sequential binary
#' parition to be used to then build an ILR basis for compositional
#' metagenomic data.
#'
#' @param tr a \code{phylo} tree object with n leaves
#' @return a n by n-1 matrix of the sequential binary partition sign matrix
#' @details
#' The choice of orientation for a balance (i.e., which of the two descendant
#' clades of an internal node is in the numerator or denominator of the
#' log-ratio) is given by the default of the function phangorn::Children
#' and that choise is used consistently throughout the philr package.
#' @author Justin Silverman
#' @references Schliep K.P. 2011. phangorn: phylogenetic analysis in R. 
#' Bioinformatics, 27(4) 592-593
#' @export
#' @seealso \code{\link{philr}}
#' @examples
#' tr <- named_rtree(5)
#' phylo2sbp(tr)
phylo2sbp <- function (tr){
    nTips <- ape::Ntip(tr)
    ch <- phangorn::Children(tr, (nTips+1):(nTips+tr$Nnode))
    ti <- phangorn::Descendants(tr,(nTips+1):(nTips+tr$Nnode), 'tips')

    # Only look for children if its an internal node
    idx <- function(x,t){
        if (x <= nTips) return(x)
        return(t[[x-nTips]])
    }

    bpVec <- function(c, t){
        tmp <- rep(0, nTips)
        tmp[idx(c[1],t)] <- 1
        tmp[idx(c[2],t)] <- -1
        return(tmp)
    }

    sbp <- sapply(ch, bpVec, ti)

    colnames(sbp) <- tr$node.label
    rownames(sbp) <- tr$tip.label

    return(sbp)
}

#' annotate_balance
#'
#' annotate a balance oriented with respect to the PhILR transform.
#' That is, you can specify labels for the numerator (\code{up}) and
#' denominator (\code{down}).
#'
#' @param tr phylo object
#' @param coord named internal node/balance to annotate
#' @param p ggtree plot (tree layer), if \code{NULL} then a new plot will be
#' created.
#' @param labels label for the numerator and denominator of the balance
#' respectively
#' @param offset offset for bar (if \code{bar=TRUE}) from tips
#' @param offset.text offset of text from bar (if \code{bar=TRUE}) or from tips
#' (if \code{bar=FALSE})
#' @param bar logical, should bar for each clade be plotted
#' @param barsize width of bar (if \code{bar=TRUE})
#' @param barfill fill of bar
#' @param geom geom used to draw label (e.g., \code{'text'} or \code{'label'})
#' @param ... additional parameters passed to \code{geom_rect} and
#' specified \code{geom}
#'
#' @return ggplot object
#' @importFrom ggplot2 annotate
#' @importFrom ggtree ggtree get_clade_position
#'
#' @export
#' @author Justin Silverman
#' @references Guangchuang Yu, David Smith, Huachen Zhu, Yi Guan,
#' Tommy Tsan-Yuk Lam.
#' \emph{ggtree: an R package for visualization and annotation of
#' phylogenetic trees with their covariates and other associated data.}
#' Methods in Ecology and Evolution 2016, \url{doi:10.1111/2041-210X.12628}
#'
#' @examples
#' tr <- named_rtree(10)
#'
#' annotate_balance(tr, 'n4', size=7)
#' annotate_balance(tr, 'n4', size=7, barsize=0.04, barfill='darkgreen',
#'     offset.text=0.05, color='red')
#' annotate_balance(tr, 'n4', bar=FALSE, size=7)
#' annotate_balance(tr, 'n4', bar=TRUE, size=7, labels=c('Num', 'Denom'),
#'     offset.text=.3)
#' annotate_balance(tr, 'n4', bar=TRUE, geom='label', size=8, offset.text=0.1)
annotate_balance <- function(tr, coord, p=NULL, labels=c('+','-'), offset=0,
                             offset.text=0.03, bar=TRUE, barsize=0.01,
                             barfill='darkgrey', geom='text', ...){

  # Check two labels were given
  if (length(labels) !=2) stop("two labels must be specified")
  names(labels) <- c('up', 'down')

  # get node numbers of children
  # get ud.nodes (to orient) - tests if coord is a tip  
  ch.coord <- unlist(get.ud.nodes(tr, coord)) 
  ch.nn <- name.to.nn(tr, ch.coord)   # Convert to node numbers
  names(ch.nn) <- names(ch.coord)

  if (is.null(p)){
    p <- ggtree::ggtree(tr)
  }

  # Create Dataframe that contains location and dimentions of bar
  xmax <- get_clade_position(p, node=name.to.nn(tr, coord))[,'xmax']
  x.up <- get_clade_position(p, node=ch.nn['up'])
  x.down <- get_clade_position(p, node=ch.nn['down'])
  x <- rbind(x.up, x.down)
  rownames(x) <- c('up','down')
  x[,'xmin'] <- xmax + offset
  x[, 'xmax'] <- x[,'xmin'] + barsize
  x[,'ymin'] <- x[,'ymin'] + 0.2
  x[,'ymax'] <- x[,'ymax'] - 0.2

  if (bar){
    p <- p +
      annotate(geom = geom,
               x=x['up',]$xmax+offset.text,
               y=(x['up',]$ymax + x['up',]$ymin)/2,
               label=labels['up'], ...) +
      annotate(geom = geom,
               x=x['down',]$xmax+offset.text,
               y=(x['down',]$ymax + x['down',]$ymin)/2,
               label=labels['down'], ...) +
      annotate('rect', xmin=x['up',]$xmin, xmax=x['up',]$xmax,
               ymin=x['up',]$ymin, ymax=x['up',]$ymax, fill=barfill) +
      annotate('rect', xmin=x['down',]$xmin, xmax=x['down',]$xmax,
               ymin=x['down',]$ymin, ymax=x['down',]$ymax, fill=barfill)
  } else {
    p <- p +
      annotate(geom = geom,
               x=xmax+offset.text,
               y=(x['up',]$ymax + x['up',]$ymin)/2,
               label=labels['up'], ...) +
      annotate(geom = geom,
               x=xmax+offset.text,
               y=(x['down',]$ymax + x['down',]$ymin)/2,
               label=labels['down'], ...)
  }
  p
}

---
title: "Introduction to PhILR"
author: "Justin Silverman"
date: "`r Sys.Date()`"
bibliography: philr.bib
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Introduction to PhILR}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---


# Introduction

PhILR is short for "Phylogenetic Isometric Log-Ratio Transform"
[@silverman2017].  This package provides functions for the analysis of
[compositional data](https://en.wikipedia.org/wiki/Compositional_data)
(e.g., data representing proportions of different
variables/parts). Specifically this package allows analysis of
compositional data where the parts can be related through a
phylogenetic tree (as is common in microbiota survey data) and makes
available the Isometric Log Ratio transform built from the
phylogenetic tree and utilizing a weighted reference measure
[@egozcue2016].

# Overview of PhILR Analysis

The goal of PhILR is to transform compositional data into an
orthogonal unconstrained space (real space) with phylogenetic /
evolutionary interpretation while preserving all information contained
in the original composition. Unlike in the original compositional
space, in the transformed real space, standard statistical tools may
be applied. For a given set of samples consisting of measurements of
taxa, we transform data into a new space of samples and orthonormal
coordinates termed ‘balances’. Each balance is associated with a
single internal node of a phylogenetic tree with the taxa as
leaves. The balance represents the log-ratio of the geometric mean
abundance of the two groups of taxa that descend from the given
internal node. More details on this method can be found in
@silverman2017 ([Link](https://elifesciences.org/content/6/e21887)).

The analysis uses abundance table and a phylogenetic tree. These can
be provided as separate data objects, or embedded in standard
R/Bioconductor data containers. The philr R package supports two
alternative data containers for microbiome data, `TreeSE` [@huang2021]
and `phyloseq` [@mcmurdie2013].


# Loading and Preprocessing Dataset 

We demonstrate PhILR analysis by using the Global Patterns
dataset that was originally published by @caporaso2011.

Let us first load necessary libraries.

```{r, echo=TRUE, message=FALSE}
library(philr); packageVersion("philr")
library(ape); packageVersion("ape")
library(ggplot2); packageVersion("ggplot2")
```


# Data preparation: TreeSE

We show the GlobalPatterns example workflow as initially
outlined in [@mcmurdie2013].

We retrieve the example data in `TreeSummarizedExperiment` (`TreeSE`)
data format in this vignette [@huang2021], and then show example also
for the [phyloseq](philr-intro-phyloseq.md) format. The TreeSE version
for the GlobalPatterns data is provided with the [`mia`
package](microbiome.github.io/mia) [@lahti2020].

Let us load the data.

```{r, echo=TRUE, message=FALSE}
library(mia); packageVersion("mia")
library(dplyr); packageVersion("dplyr")
data(GlobalPatterns, package = "mia")
```


## Filter Extremely Low-Abundance OTUs

Taxa that were not seen with more than 3 counts in at least 20% of
samples are filtered.  Subsequently, those with a coefficient of
variation ≤ 3 are filtered. Finally we add a pseudocount of 1 to the
remaining OTUs to avoid calculating log-ratios involving
zeros. Alternatively other replacement methods (multiplicative
replacement etc...) may be used instead if desired; the subsequent
taxa weighting procedure we will describe complements a variety of
zero replacement methods.

```{r, message=FALSE, warning=FALSE}
## Select prevalent taxa 
tse <-  GlobalPatterns %>% subsetByPrevalentTaxa(
                               detection = 3,
                               prevalence = 20/100,
                               as_relative = FALSE)

## Pick taxa that have notable abundance variation across sammples
variable.taxa <- apply(assays(tse)$counts, 1, function(x) sd(x)/mean(x) > 3.0)
tse <- tse[variable.taxa,]
# Collapse the tree!
# Otherwise the original tree with all nodes is kept
# (including those that were filtered out from rowData)
tree <- ape::keep.tip(phy = rowTree(tse), tip = rowLinks(tse)$nodeNum)
rowTree(tse) <- tree

## Add a new assay with a pseudocount 
assays(tse)$counts.shifted <- assays(tse)$counts + 1 
```

We have now removed the filtered taxa from the OTU table, 
pruned the phylogenetic tree, and subset the taxa table. 
Here is the result of those filtering steps.

```{r, echo=FALSE}
tse
```



## Process Phylogenetic Tree

Next we check that the tree is rooted and binary (all multichotomies
have been resolved).

```{r, message=FALSE, warning=FALSE}
library(ape); packageVersion("ape")
is.rooted(tree) # Is the tree Rooted?
is.binary(tree) # All multichotomies resolved?
```

Note that if the tree is not binary, the function `multi2di` from the
`ape` package can be used to replace multichotomies with a series of
dichotomies with one (or several) branch(es) of zero length.

Once this is done, we name the internal nodes of the tree so they are
easier to work with. We prefix the node number with `n` and thus the
root is named `n1`.

```{r, message=FALSE, warning=FALSE}
tree <- makeNodeLabel(tree, method="number", prefix='n')

# Add the modified tree back to the (`TreeSE`) data object 
rowTree(tse) <- tree
```

We note that the tree is already rooted with Archea as the outgroup
and no multichotomies are present. This uses the function
`name.balance` from the `philr` package. This function uses a simple
voting scheme to find a consensus naming for the two clades that
descend from a given balance. Specifically for a balance named `x/y`,
`x` refers to the consensus name of the clade in the numerator of the
log-ratio and `y` refers to the denominator.

```{r}
# Extract taxonomy table from the TreeSE object
tax <- rowData(tse)[,taxonomyRanks(tse)]

# Get name balances
name.balance(tree, tax, 'n1')
```


## Investigate Dataset Components

Finally we transpose the OTU table (`philr` uses the conventions of
the `compositions` package for compositional data analysis in R, taxa
are columns, samples are rows). Then we will take a look at part of
the dataset in more detail.

```{r}
otu.table <- t(as(assays(tse)$counts.shifted, "matrix"))
tree <- rowTree(tse)
metadata <- colData(tse)
tax <- rowData(tse)[,taxonomyRanks(tse)]

otu.table[1:2,1:2] # OTU Table
tree # Phylogenetic Tree
head(metadata,2) # Metadata
head(tax,2) # taxonomy table
```


A new variable distinguishing human/non-human:

```{r}
human.samples <- factor(colData(tse)$SampleType %in% c("Feces", "Mock", "Skin", "Tongue"))
```



# Transform Data using PhILR

The function `philr::philr()` implements a user friendly wrapper for the key 
steps in the philr transform. 

1. Convert the phylogenetic tree to its sequential binary partition (SBP) representation
using the function `philr::phylo2sbp()`
2. Calculate the weighting of the taxa (aka parts) or use the user specified weights
3. Built the contrast matrix from the SBP and taxa weights using the function 
`philr::buildilrBasep()`
4. Convert OTU table to relative abundance (using `philr::miniclo()`) and 
'shift' dataset using the weightings [@egozcue2016] using the function `philr::shiftp()`.
5. Transform the data to PhILR space using the function `philr::ilrp()`
6. (Optional) Weight the resulting PhILR space using phylogenetic distance. These
weights are either provided by the user or can be calculated by the function 
`philr::calculate.blw()`. 

Note: The preprocessed OTU table should be passed to the function
`philr::philr()` before it is closed (normalized) to relative
abundances, as some of the preset weightings of the taxa use the
original count data to down weight low abundance taxa.

Here we will use the same weightings as we used in the main paper.

You can run `philr` with the abundance table and phylogenetic tree.

```{r, message=FALSE}
gp.philr <- philr(otu.table, tree, 
                  part.weights='enorm.x.gm.counts', 
                  ilr.weights='blw.sqrt')
gp.philr[1:5,1:5]
```


Alternatively, you can provide the data directly in `TreeSE` format.

```{r, message=FALSE}
gp.philr <- philr(tse, abund_values = "counts.shifted",
                  part.weights='enorm.x.gm.counts', 
                  ilr.weights='blw.sqrt')
```

Alternatively, you can provide the data in `phyloseq` format. For
simplicity, let us just convert the `TreeSE` object to `phyloseq`
object to give a brief example.

```{r, message=FALSE}
pseq <- convertToPhyloseq(tse, assay.type="counts.shifted")
gp.philr <- philr(pseq, 
                  part.weights='enorm.x.gm.counts', 
                  ilr.weights='blw.sqrt')

```



After running `philr` the transformed data is represented in terms of
balances and since each balance is associated with a single internal
node of the tree, we denote the balances using the same names we
assigned to the internal nodes (e.g., `n1`).


# Ordination in PhILR Space

Euclidean distance in PhILR space can be used for ordination analysis. Let us first calculate distances and then calculate standard MDS ordination. 

```{r}
# Distances between samples based on philr transformed data
gp.dist <- dist(gp.philr, method="euclidean") 

# Calculate MDS for the distance matrix
d <- as.data.frame(cmdscale(gp.dist))
colnames(d) <- paste0("PC", 1:2)
```


# Visualization with TreeSE

Let us next visualize the ordination. This example employs standard
tools for ordination and visualization that can be used regardless of
the preferred data container. Note that the `phyloseq` and `TreeSE` frameworks
may provide access to additional ordination and visualization methods.

```{r}
# Add some metadata for the visualization 
d$SampleType <- factor(metadata$SampleType)

# Create a plot
ggplot(data = d,
  aes(x=PC1, y=PC2, color=SampleType)) +
  geom_point() +
  labs(title = "Euclidean distances with phILR")
```



# Identify Balances that Distinguish Human/Non-Human

More than just ordination analysis, PhILR provides an entire
coordinate system in which standard multivariate tools can be
used. Here we will make use of sparse logistic regression (from the
`glmnet` package) to identify a small number of balances that best
distinguish human from non-human samples.

Now we will fit a sparse logistic regression model (logistic
regression with $l_1$ penalty)

```{r, message=FALSE, warning=FALSE}
library(glmnet); packageVersion('glmnet')
glmmod <- glmnet(gp.philr, human.samples, alpha=1, family="binomial")
```

We will use a hard-threshold for the $l_1$ penalty of $\lambda =
0.2526$ which we choose so that the resulting number of non-zero
coefficients is $\approx 5$ (for easy of visualization in this
tutorial).

```{r}
top.coords <- as.matrix(coefficients(glmmod, s=0.2526))
top.coords <- rownames(top.coords)[which(top.coords != 0)]
(top.coords <- top.coords[2:length(top.coords)]) # remove the intercept as a coordinate
```

# Name Balances

To find the taxonomic labels that correspond to these balances we can
use the function `philr::name.balance()`. This funciton uses a simple
voting scheme to name the two descendent clades of a given balance
separately. For a given clade, the taxonomy table is subset to only
contain taxa from that clade. Starting at the finest taxonomic rank
(e.g., species) the subset taxonomy table is checked to see if any
label (e.g., species name) represents ≥ threshold (default 95%) of the
table entries at that taxonomic rank. If no consensus identifier is
found, the table is checked at the next-most specific taxonomic rank
(etc...).

```{r}
tc.names <- sapply(top.coords, function(x) name.balance(tree, tax, x))
tc.names
```

We can also get more information on what goes into the naming by viewing the votes 
directly.

```{r}
votes <- name.balance(tree, tax, 'n730', return.votes = c('up', 'down'))
votes[[c('up.votes', 'Family')]]   # Numerator at Family Level
votes[[c('down.votes', 'Family')]] # Denominator at Family Level
```




# Visualize Results

```{r, message=FALSE, warning=FALSE}
library(ggtree); packageVersion("ggtree")
library(dplyr); packageVersion('dplyr')
```

Above we found the top 5 coordinates (balances) that distinguish
whether a sample is from a human or non-human source. Now using the
`ggtree` [@yu2016] package we can visualize these balances on the tree
using the `geom_balance` object.  To use these functions we need to
know the acctual node number (not just the names we have given) of
these balances on the tree. To convert between node number and name,
we have added the functions `philr::name.to.nn()` and
`philr::nn.to.name()`.  In addition, it is important that we know
which clade of the balance is in the numerator (+) and which is in the
denominator (-) of the log-ratio. To help us keep track we have
created the function `philr::annotate_balance()` which allows us to
easily label these two clades.

```{r, message=FALSE, warning=FALSE}
tc.nn <- name.to.nn(tree, top.coords)
tc.colors <- c('#a6cee3', '#1f78b4', '#b2df8a', '#33a02c', '#fb9a99')
p <- ggtree(tree, layout='fan') +
  geom_balance(node=tc.nn[1], fill=tc.colors[1], alpha=0.6) +
  geom_balance(node=tc.nn[2], fill=tc.colors[2], alpha=0.6) +
  geom_balance(node=tc.nn[3], fill=tc.colors[3], alpha=0.6) +
  geom_balance(node=tc.nn[4], fill=tc.colors[4], alpha=0.6) +
  geom_balance(node=tc.nn[5], fill=tc.colors[5], alpha=0.6)
p <- annotate_balance(tree, 'n16', p=p, labels = c('n16+', 'n16-'),
                 offset.text=0.15, bar=FALSE)
annotate_balance(tree, 'n730', p=p, labels = c('n730+', 'n730-'),
                 offset.text=0.15, bar=FALSE)
```

We can also view the distribution of these 5 balances for human/non-human sources.
In order to plot with `ggplot2` we first need to convert the PhILR transformed
data to long format. We have included a function `philr::convert_to_long()` for
this purpose. 

```{r}
gp.philr.long <- convert_to_long(gp.philr, human.samples) %>%
  filter(coord %in% top.coords)

ggplot(gp.philr.long, aes(x=labels, y=value)) +
  geom_boxplot(fill='lightgrey') +
  facet_grid(.~coord, scales='free_x') +
  labs(x = 'Human', y = 'Balance Value') +
  theme_bw()
```

# Use Balances for Dimension Reduction

Lets just look at balance n16 vs. balance n730 (the ones we annotated
in the above tree).

```{r, message=FALSE, warning=FALSE}
library(tidyr); packageVersion('tidyr')

gp.philr.long %>%
  dplyr::rename(Human=labels) %>%
  dplyr::filter(coord %in% c('n16', 'n730')) %>%
  tidyr::spread(coord, value) %>%
  ggplot(aes(x=n16, y=n730, color=Human)) +
  geom_point(size=4) +
  labs(x = tc.names['n16'], y = tc.names['n730']) +
  theme_bw()
```



# Package versions

```{r, echo=TRUE, message=FALSE}
sessionInfo()
```


# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/branch_length_calculations.R
\name{mean_dist_to_tips}
\alias{mean_dist_to_tips}
\title{Mean distance from internal nodes to descendant tips}
\usage{
mean_dist_to_tips(tree)
}
\arguments{
\item{tree}{a \code{phylo} class tree object that is binary (see
\code{\link[ape]{multi2di}})}
}
\value{
vector (named if internal nodes are named)
}
\description{
Calculates the mean distance from each internal node to its descendant tips
}
\details{
This is a function used by \code{\link{calculate.blw}} when
  \code{method='mean.descendants'}, there this function is called twice, once
  for each direct child of a given internal node and the results are summed
  for each node.
}
\examples{
tr <- named_rtree(5)
mean_dist_to_tips(tr)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/name_balances.R
\name{name.balance}
\alias{name.balance}
\title{Name a balance (coordinate) based on taxonomy}
\usage{
name.balance(
  tr,
  tax,
  coord,
  method = "voting",
  thresh = 0.95,
  return.votes = NULL
)
}
\arguments{
\item{tr}{an object of class \code{'phylo'}}

\item{tax}{a matrix/data.frame of taxonomy, rownames should correspond to
\code{tr$tip.labels} columns should be taxonomic levels (named) with
increasing taxonomic resolution from left to right (e.g., Phylum to the
left of Genus).}

\item{coord}{the name of a balance/internal node on the tree (given as a
string)}

\item{method}{currently only \code{'voting'} implemented. See Details.}

\item{thresh}{threshold for assignment of taxonomy to a given part of a
balance (must be greater than 0.5 if \code{method='voting'}; see details).}

\item{return.votes}{whether voting results by taxonomic level should be
shown for \code{coord}. Note: this is helpful when \code{name.balance} does
not return a clear winner, as may be the case when a given \code{coord}
represents more than one taxonomic lineage. votes are returned as a list
indexed by \code{colnames(tax)} Options include:
\describe{
\item{\code{NULL}}{(default) only returns the combined consensus name of
   the balance}
\item{\code{'up'}}{adds tallied votes for the 'up' node to the output list}
\item{\code{'down'}}{adds tallied votes for the 'down' node to the output
   list}
\item{\code{'self'}}{adds tallied votes for \code{coord} to the output list}
}}
}
\value{
If \code{return.votes=NULL} returns a string of the form
(ex. 'Genus_Bacteroides/Phylum_Firmicutes'). Otherwise returns
a list with the above string as 'name', see Arguments for \code{show.votes}
for other optional returned items.
}
\description{
For a given ILR balance (coordinate) assigns a name to the balance based on
a provided taxonomy table. This is useful for interpretation of the balances.
}
\details{
A bit of terminology:
\describe{
\item{coord}{this is the same as the names of the balances which should be
the same as the names of the internal nodes of \code{tr}}
\item{'up'}{this is the child node of \code{coord} that is represented in
the numerator of the \code{coord} balance.}
\item{'down'}{this is the child node of \code{coord} that is represented in
the denominator of the \code{coord} balance}
}
The method \code{'voting'} assigns the name of the each part of a balance
(e.g., numerator and denominator / each child of \code{coord}) as follows:
\enumerate{
\item First Subset \code{tax} to contain only descendent tips of the given
child of \code{coord}
\item Second At the finest taxonomic (farthest right of \code{tax}) see if
any one taxonomic label is present at or above \code{thresh}. If yes output
that taxonomic label (at that taxonomic level) as the label for that child
of \code{coord}. If no then move to coarser taxonomic level (leftward) and
repeat.
}
}
\examples{
tr <- named_rtree(40)
tax <- data.frame(Kingdom=rep('A', 40),
               Phylum=rep(c('B','C'), each=20),
               Genus=c(sample(c('D','F'),20, replace=TRUE),
                       sample(c('G','H'), 20, replace=TRUE)))
rownames(tax) <- tr$tip.label
name.balance(tr, tax, 'n1')
name.balance(tr, tax, 'n34')
name.balance(tr,tax, 'n34', return.votes = c('up', 'down'))
}
\seealso{
\code{\link{philr}}
}
\author{
Justin Silverman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/branch_length_calculations.R
\name{calculate.blw}
\alias{calculate.blw}
\alias{calc.blw}
\title{Calculate Branch Length Weightings for ILR Coordinates}
\usage{
calculate.blw(tree, method = "sum.children")
}
\arguments{
\item{tree}{a \code{phylo} class tree object that is binary (see
\code{\link[ape]{multi2di}})}

\item{method}{options include: (default) \code{'sum.children'} and
\code{'mean.descendants'}
see details for more information.}
}
\value{
vector of weightings for ILR coordinates produced via specified
method.
}
\description{
Calculates the weightings for ILR coordinates based on branch lenghts of
a phylogenetic tree via a few different methods (see details).
}
\details{
ILR balances built from a binary partition of a phylogenetic tree
can be imbued with branch length information. This function is helpful in
calculating those weightings.\cr \cr
There are a number of methods for calculating these weightings, the default
\code{'sum.children'} calculates the weighting for a given balance as the sum
of its two direct children's branch length. An alternative that has been
as yet less studied is \code{'mean.descendants'} to calculate the weighting
for a given balance as the sum of its two direct children's branch lengths
PLUS for each child the average distance from it to its descendant tips.
\cr \cr
\emph{Note:} That some trees contain tips with branch lengths of zero length.
This can result in that tip being unreasonably downweighted, as such this
function automatically adds a small pseudocount to those tips with zero
length (equal to the smallest non-zero)
branch length on the tree.
}
\examples{
tr <- named_rtree(50)
calculate.blw(tr, method='sum.children')[1:10]
calculate.blw(tr, method='mean.descendants')[1:10]
}
\seealso{
\code{\link{philr}}
}
\author{
Justin Silverman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_utils.R
\name{name_nodenumber_conversion}
\alias{name_nodenumber_conversion}
\alias{nn.to.name}
\alias{name.to.nn}
\title{Convert between node/tip labels and integer node numbers}
\usage{
nn.to.name(tr, x)

name.to.nn(tr, x)
}
\arguments{
\item{tr}{object of type \code{phylo}}

\item{x}{vector of numerics or characters}
}
\value{
vector
}
\description{
Useful if you want to convert between node labels (\code{c}), tip labels
(\code{t}) and the internal integer number that identifies that node
(\code{nn}). Particularly for use with plotting libraries.
}
\examples{
tr <- named_rtree(5)
name.to.nn(tr, 'n1')
name.to.nn(tr,c('n1','n2','t1'))
nn.to.name(tr, 1:9)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_utils.R
\name{convert_to_long}
\alias{convert_to_long}
\title{Converts wide format ILR transformed data to long format}
\usage{
convert_to_long(x, labels)
}
\arguments{
\item{x}{PhILR transformed data in wide format (samples by balances)
(see \code{\link{philr}})}

\item{labels}{vector (of length \code{nrow(x)}) with labels to group
samples by}
}
\value{
\code{x} in long format with columns
\itemize{
\item sample
\item labels
\item coord
\item value
}
}
\description{
Converts wide format ILR transformed data (see \code{\link{philr}}) to
long format useful in various plotting functions where long format data is
required.
}
\examples{
tr <- named_rtree(5)
x <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65 # add small pseudocount
colnames(x) <- tr$tip.label

x.philr <- philr(x, tree=tr, part.weights='enorm.x.gm.counts',
   ilr.weights='blw.sqrt', return.all=FALSE)
   convert_to_long(x.philr, rep(c('a','b'), 5))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/weighted_ILR.R
\name{shift}
\alias{shift}
\alias{shiftp}
\alias{shiftpInv}
\title{Shift data to origin given by p}
\usage{
shiftp(x, p)

shiftpInv(y, p)
}
\arguments{
\item{x}{closed compositional data matrix (or vector)}

\item{p}{weights (should not be closed)}

\item{y}{the shifted composition output by \code{shiftp}}
}
\value{
shifted data matrix \code{y} (no closure is applied) rows are
  samples, columns are parts
}
\description{
Shift must be applied before transformation
}
\examples{
p <- seq(.1,1,by=.2)
c <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65   # add a small pseudocount
x <- miniclo(c)
shiftp(x, p)
}
\references{
J. J. Egozcue, V. Pawlowsky-Glahn (2016) \emph{Changing the Reference
  Measure in the Simplex and its Weighting Effects}. Austrian Journal of
  Statistics 45(4):25-44
}
\author{
Justin Silverman & J. J. Egozcue
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/weighted_ILR.R
\name{clrp}
\alias{clrp}
\alias{clrpInv}
\title{Weighted CLR Transform}
\usage{
clrp(y, p)

clrpInv(y.star)
}
\arguments{
\item{y}{shifted data matrix (e.g., output of \link{shiftp})}

\item{p}{weights (should not be closed)}

\item{y.star}{a data matrix that represents data transformed by \code{clrp}}
}
\value{
matrix
}
\description{
Weighted CLR Transform
}
\details{
Note that this function will close the dataset \code{y} to 1.

Inverting \code{clrp} transform should be followed by \code{shiftpInv}
to return to unshifted original compositoin (see examples).
}
\examples{
p <- seq(.1,1,by=.2)
c <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65   # add a small pseudocount
x <- miniclo(c)
y <- shiftp(x, p)
y.star <- clrp(y, p)
y.star

# Untransform data (note use of shiftp and miniclo to return to x)
y.closed <- clrpInv(y.star)
all.equal(miniclo(shiftpInv(y.closed, p)), x)
}
\references{
J. J. Egozcue, V. Pawlowsky-Glahn (2016) \emph{Changing the Reference
  Measure in the Simplex and its Weighting Effects}. Austrian Journal of
  Statistics 45(4):25-44
}
\author{
Justin Silverman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/weighted_ILR.R
\name{buildilrBasep}
\alias{buildilrBasep}
\title{Weighted ILR Contrast Matrix}
\usage{
buildilrBasep(W, p)
}
\arguments{
\item{W}{sequantial binary partition matrix (e.g., signary matrix; output of
\link{phylo2sbp})}

\item{p}{weights (should not be closed)}
}
\value{
matrix
}
\description{
Weighted ILR Contrast Matrix
}
\examples{
p <- seq(.1,1,by=.2)
tr <- named_rtree(5)
sbp <- phylo2sbp(tr)
buildilrBasep(sbp, p)
}
\references{
J. J. Egozcue, V. Pawlowsky-Glahn (2016) \emph{Changing the Reference
  Measure in the Simplex and its Weighting Effects}. Austrian Journal of
  Statistics 45(4):25-44
}
\author{
Justin Silverman (adapted from compositions::gsi.buildilrBase)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/weighted_ILR.R
\name{g.rowMeans}
\alias{g.rowMeans}
\title{Weighted Geometric Means of Rows}
\usage{
g.rowMeans(y, p = rep(1, nrow(y)))
}
\arguments{
\item{y}{shifted data matrix (e.g., output of \link{shiftp})}

\item{p}{weights (should not be closed)}
}
\value{
vector (weighted geometric mean of rows)
}
\description{
Calculates weighted geometric mean (see references). Note
if \code{p=rep(1, nrow(y))} (default) then this is just the
geometric mean of rows.
}
\examples{
p <- seq(.1,1,by=.2)
c <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65   # add a small pseudocount
x <- miniclo(c)
y <- shiftp(x, p)
philr:::g.rowMeans(y, p)
}
\references{
J. J. Egozcue, V. Pawlowsky-Glahn (2016) \emph{Changing the Reference
  Measure in the Simplex and its Weighting Effects}. Austrian Journal of
  Statistics 45(4):25-44
}
\seealso{
\code{\link{g.colMeans}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_utils.R
\name{named_rtree}
\alias{named_rtree}
\title{Generate random tree with named internal nodes}
\usage{
named_rtree(n)
}
\arguments{
\item{n}{an integer giving the number of tips in the tree.}
}
\value{
An object of class "phylo"
}
\description{
Internal nodes are named by numbering and adding the prefix 'n'. This
function is laregly for use in examples throughout this package.
}
\examples{
named_rtree(5)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_utils.R
\name{annotate_balance}
\alias{annotate_balance}
\title{annotate_balance}
\usage{
annotate_balance(
  tr,
  coord,
  p = NULL,
  labels = c("+", "-"),
  offset = 0,
  offset.text = 0.03,
  bar = TRUE,
  barsize = 0.01,
  barfill = "darkgrey",
  geom = "text",
  ...
)
}
\arguments{
\item{tr}{phylo object}

\item{coord}{named internal node/balance to annotate}

\item{p}{ggtree plot (tree layer), if \code{NULL} then a new plot will be
created.}

\item{labels}{label for the numerator and denominator of the balance
respectively}

\item{offset}{offset for bar (if \code{bar=TRUE}) from tips}

\item{offset.text}{offset of text from bar (if \code{bar=TRUE}) or from tips
(if \code{bar=FALSE})}

\item{bar}{logical, should bar for each clade be plotted}

\item{barsize}{width of bar (if \code{bar=TRUE})}

\item{barfill}{fill of bar}

\item{geom}{geom used to draw label (e.g., \code{'text'} or \code{'label'})}

\item{...}{additional parameters passed to \code{geom_rect} and
specified \code{geom}}
}
\value{
ggplot object
}
\description{
annotate a balance oriented with respect to the PhILR transform.
That is, you can specify labels for the numerator (\code{up}) and
denominator (\code{down}).
}
\examples{
tr <- named_rtree(10)

annotate_balance(tr, 'n4', size=7)
annotate_balance(tr, 'n4', size=7, barsize=0.04, barfill='darkgreen',
    offset.text=0.05, color='red')
annotate_balance(tr, 'n4', bar=FALSE, size=7)
annotate_balance(tr, 'n4', bar=TRUE, size=7, labels=c('Num', 'Denom'),
    offset.text=.3)
annotate_balance(tr, 'n4', bar=TRUE, geom='label', size=8, offset.text=0.1)
}
\references{
Guangchuang Yu, David Smith, Huachen Zhu, Yi Guan,
Tommy Tsan-Yuk Lam.
\emph{ggtree: an R package for visualization and annotation of
phylogenetic trees with their covariates and other associated data.}
Methods in Ecology and Evolution 2016, \url{doi:10.1111/2041-210X.12628}
}
\author{
Justin Silverman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/weighted_ILR.R
\name{miniclo}
\alias{miniclo}
\title{miniclo}
\usage{
miniclo(c, k = 1)
}
\arguments{
\item{c}{dataset to be closed}

\item{k}{closure constant}
}
\value{
matrix (if c is a vector or matrix) or data.frame (if c is a data.frame)
}
\description{
small function to close (aka normalize by proportions, aka total sum scaling)
a dataset to a constant \code{k} (usually taken to be 1). After closure the row sums
of the dataset should sum to \code{k}.
}
\examples{
c <- matrix(c(1,2,3,1,2,3,1,2,3), nrow = 3, byrow=TRUE)
miniclo(c)
miniclo(c, k=2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/philr.R
\name{philr}
\alias{philr}
\alias{build.phylo.ilr}
\title{Data transformation and driver of PhILR.}
\usage{
philr(
  x,
  tree = NULL,
  sbp = NULL,
  part.weights = "uniform",
  ilr.weights = "uniform",
  return.all = FALSE,
  pseudocount = 0,
  abund_values = "counts",
  ...
)
}
\arguments{
\item{x}{\strong{matrix} of data to be transformed (samples are rows, compositional parts are
columns) - zero must be dealt with either with pseudocount, multiplicative replacement, or
another method.}

\item{tree}{a \code{phylo} class tree object that is binary (see
\code{\link[ape]{multi2di}})}

\item{sbp}{(Optional) give a precomputed sbp matrix \code{\link{phylo2sbp}} if you are going to
build multiple ILR bases (e.g., with different weightings).}

\item{part.weights}{weightings for parts, can be a named vector with names corresponding to
\code{colnames(x)} otherwise can be a string, options include: \describe{
\item{\code{'uniform'}}{(default) uses the uniform reference measure}
\item{\code{'gm.counts'}}{geometric mean of parts of x} \item{\code{'anorm'}}{aitchison norm of
parts of x (after closure)} \item{\code{'anorm.x.gm.counts'}}{\code{'anorm'} times
\code{'gm.counts'}} \item{\code{'enorm'}}{euclidean norm of parts of x (after closure)}
\item{\code{'enorm.x.gm.counts'}}{\code{'enorm'} times \code{'gm.counts'}, often gives good
results} }}

\item{ilr.weights}{weightings for the ILR coordiantes can be a named vector with names
corresponding to names of internal nodes of \code{tree} otherwise can be a string, options
include: \describe{ \item{\code{'uniform'}}{(default) no weighting of the ILR basis}
\item{\code{'blw'}}{sum of children's branch lengths} \item{\code{'blw.sqrt'}}{square root of
\code{'blw'} option} \item{\code{'mean.descendants'}}{sum of children's branch lengths PLUS the
sum of each child's mean distance to its descendent tips} }}

\item{return.all}{return all computed parts (e.g., computed sign matrix(\code{sbp}), part
weightings (code{p}), ilr weightings (code{ilr.weights}), contrast matrix (\code{V})) as a list
(default=\code{FALSE}) in addition to in addition to returning the transformed data
(\code{.ilrp}). If \code{return.all==FALSE} then only returns the transformed data (not in list
format) If \code{FALSE} then just returns list containing \code{x.ilrp}.}

\item{pseudocount}{optional pseudocount added to observation matrix (`x`) to avoid numerical
issues from zero values. Default value is 0 which has no effect (allowing the user to handle
zeros in their own preffered way before calling philr). Values < 0 given an error.}

\item{abund_values}{A single character value for selecting the
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-class]{assay}} to be used. Only
used when \code{x} is object from this class. Default: "counts".}

\item{...}{other parameters passed to philr.data.frame or philr.TreeSummarizedExperiment}
}
\value{
matrix if \code{return.all=FALSE}, if \code{return.all=TRUE} then
a list is returned (see above).
}
\description{
This is the main function for building the phylogenetic ILR basis,
calculating the weightings (of the parts and the ILR coordinates) and then
transforming the data.
}
\details{
This is a utility function that pulls together a number of other functions in
  \code{philr}. The steps that are executed are as follows: \enumerate{ \item Create sbp (sign
  matrix) if not given \item Create parts weightings if not given \item Shift the dataset with
  respect to the new reference measure (e.g., part weightings) \item Create the basis contrast
  matrix from the sign matrix and the reference measure \item Transform the data based on the
  contrast matrix and the reference measure \item Calculate the specified ILR weightings and
  multiply each balance by the corresponding weighting } Note for both the reference measure
  (part weightings) and the ILR weightings, specifying \code{'uniform'} will give the same
  results as not weighting at all. \cr \cr Note that some of the prespecified part.weights assume
  \code{x} is given as counts and not as relative abundances. Except in this case counts or
  relative abundances can be given.

The tree argument is ignored if the \code{x} argument is
\code{\link[phyloseq:phyloseq-class]{assay}} or
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-class]{assay}}
These objects can include a phylogenetic tree. If the phylogenetic tree
is missing from these objects, it should be integrated directly in these
data objects before running \code{philr}. Alternatively, you can always
provide the abundance matrix and tree separately in their standard formats.

If you have a 
\code{\link[SummarizedExperiment:SummarizedExperiment-class]{assay}},
this can be converted into
\code{\link[TreeSummarizedExperiment:TreeSummarizedExperiment-class]{assay}},
to incorporate tree information.
}
\examples{
# Prepare example data
tr <- named_rtree(5)
x <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65 # add a small pseudocount
colnames(x) <- tr$tip.label
philr(x, tr, part.weights='enorm.x.gm.counts',
               ilr.weights='blw.sqrt', return.all=FALSE)

# Running philr on a TreeSummarizedExperiment object

## Prepare example data
library(mia)
library(tidyr)
data(GlobalPatterns, package="mia")

## Select prevalent taxa 
tse <-  GlobalPatterns \%>\% subsetByPrevalentTaxa(
                               detection = 3,
                               prevalence = 20/100,
                               as_relative = FALSE)

## Pick taxa that have notable abundance variation across sammples
variable.taxa <- apply(assay(tse, "counts"), 1, function(x) sd(x)/mean(x) > 3.0)
tse <- tse[variable.taxa,]

# Collapse the tree
tree <- ape::keep.tip(phy = rowTree(tse), tip = rowLinks(tse)$nodeNum)
rowTree(tse) <- tree

## Add a new assay with a pseudocount 
assays(tse)$counts.shifted <- assay(tse, "counts") + 1

## Run philr for TreeSummarizedExperiment object
## using the pseudocount data
res.tse <- philr(tse, part.weights='enorm.x.gm.counts',
               ilr.weights='blw.sqrt', return.all=FALSE,
               abund_values="counts.shifted")

# Running philr on a phyloseq object
\dontrun{
  pseq <- convertToPhyloseq(tse)
  res.pseq <- philr(pseq, part.weights='enorm.x.gm.counts',
               ilr.weights='blw.sqrt', return.all=FALSE,
               pseudocount=0.5)
}

}
\seealso{
\code{\link{phylo2sbp}} \code{\link{calculate.blw}}
}
\author{
Justin Silverman; S3 methods by Leo Lahti
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/weighted_ILR.R
\name{g.colMeans}
\alias{g.colMeans}
\title{Geometric Means of Columns}
\usage{
g.colMeans(x)
}
\arguments{
\item{x}{matrix or vector}
}
\value{
vector (geometric mean of columns)
}
\description{
Calculates geometric mean of columns. Does not calculate
WEIGHTED geometric means (vs. \link{g.rowMeans})
}
\examples{
philr:::g.colMeans(rbind(c(2,4,4), c(2,4,4)))
}
\seealso{
g.rowMeans
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/phylo2sbp.R
\name{phylo2sbp}
\alias{phylo2sbp}
\title{Create Sequential Binary Partition from Phylogenetic Tree}
\usage{
phylo2sbp(tr)
}
\arguments{
\item{tr}{a \code{phylo} tree object with n leaves}
}
\value{
a n by n-1 matrix of the sequential binary partition sign matrix
}
\description{
This function converts a binary phylogenetic tree to sequential binary
parition to be used to then build an ILR basis for compositional
metagenomic data.
}
\details{
The choice of orientation for a balance (i.e., which of the two descendant
clades of an internal node is in the numerator or denominator of the
log-ratio) is given by the default of the function phangorn::Children
and that choise is used consistently throughout the philr package.
}
\examples{
tr <- named_rtree(5)
phylo2sbp(tr)
}
\references{
Schliep K.P. 2011. phangorn: phylogenetic analysis in R. 
Bioinformatics, 27(4) 592-593
}
\seealso{
\code{\link{philr}}
}
\author{
Justin Silverman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/weighted_ILR.R
\name{ilrp}
\alias{ilrp}
\alias{ilrpInv}
\title{Weighted ILR Transform}
\usage{
ilrp(y, p, V)

ilrpInv(y.star, V)
}
\arguments{
\item{y}{shifted data matrix (e.g., output of \link{shiftp})}

\item{p}{weights (should not be closed)}

\item{V}{weighted contrast matrix (e.g., output of \link{buildilrBasep})}

\item{y.star}{a data matrix that represents data transformed by \code{ilrp}}
}
\value{
matrix
}
\description{
Calculated using weighted CLR transform (\link{clrp})
}
\examples{
# Weights
p <- seq(.1,1,by=.2)

# Shifted Composition
c <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65   # add a small pseudocount
x <- miniclo(c)
y <- shiftp(x, p)

# Contrast Matrix
tr <- named_rtree(5)
sbp <- phylo2sbp(tr)
V <- buildilrBasep(sbp, p)

y.star <- ilrp(y, p, V)
y.star

# Untransform data (note use of shiftp and miniclo to return to x)
y.closed <- ilrpInv(y.star, V)
all.equal(miniclo(shiftpInv(y.closed, p)), x, check.attributes=FALSE)
}
\references{
J. J. Egozcue, V. Pawlowsky-Glahn (2016) \emph{Changing the Reference
  Measure in the Simplex and its Weighting Effects}. Austrian Journal of
  Statistics 45(4):25-44
}
\seealso{
\code{\link{philrInv}}
}
\author{
Justin Silverman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/philr.R
\name{philrInv}
\alias{philrInv}
\title{Inverse of PhILR Transform}
\usage{
philrInv(
  x.ilrp,
  tree = NULL,
  sbp = NULL,
  V = NULL,
  part.weights = NULL,
  ilr.weights = NULL
)
}
\arguments{
\item{x.ilrp}{transformed data to which the inverse transform will be applied}

\item{tree}{(optional) to be used to build sbp and contrast matrix
(see details)}

\item{sbp}{(optional) the sbp (sequential binary partition) used to build a
contrast matrix (see details)}

\item{V}{(optional) the contrast matrix (see details)}

\item{part.weights}{weightings for parts, can be a named vector with names
corresponding to \code{colnames(x)}. Defaults to 'uniform'
(part.weights = 1,...,1)}

\item{ilr.weights}{weightings for the ILR coordiantes can be a named vector
with names corresponding to names of internal nodes of \code{tree}.
Defaults to 'uniform' (ilr.weights = 1,...,1)}
}
\value{
a matrix of compositions (rows are samples, columns are parts),
function removes the effects of ilr weights, part weights, and unshifts
the composition.
}
\description{
Inverse of PhILR Transform
}
\details{
This is a utility function for calculating the inverse of the
\code{\link{philr}} transform. Note that at least one of the following
parameters must be specified (\code{tree}, \code{sbp}, or \code{V}).
}
\examples{
 tr <- named_rtree(5)
 x <- t(rmultinom(10,100,c(.1,.6,.2,.3,.2))) + 0.65 # add small pseudocount
 colnames(x) <- tr$tip.label
 d <- philr(x, tr, part.weights='enorm.x.gm.counts',
                ilr.weights='blw.sqrt', return.all=TRUE)
 d.inverted <- philrInv(d$x.ilrp, V=d$V, part.weights = d$p,
                        ilr.weights = d$ilr.weights)
 all.equal(miniclo(x), d.inverted)
}
\seealso{
\code{\link{philr}}
}
\author{
Justin Silverman
}
